Scriptname TweakDawnGuardScript extends Quest Conditional

Bool 		Property Installed 		Auto Conditional
Bool 		Property PlayerIsLord 	Auto Conditional

; Actors and Quests
Actor 		Property Serena 					Auto
ActorBase	Property SerenaBase 				Auto
ActorBase	Property TrollFollowerBase			Auto
ReferenceAlias 	Property SerenaRef 				Auto
Quest 		Property DLC1NPCMentalModel 		Auto

Spell[] 	Property SpellMap					Auto 
String[]	Property SpellNames					Auto
Int[]		Property SpellCosts					Auto
Int[]		Property SpellSchools				Auto

; Vampire Abilities
Spell 	Property ConjureGargoyleLeftHand 		Auto
Spell 	Property CorpseCurseLeftHand 			Auto
Spell	Property MastersGaze 					Auto
Spell	Property DLC1VampireDrain05				Auto
Spell	Property DLC1VampireDrain06         	Auto
Spell	Property DLC1VampireDrain07         	Auto
Spell	Property DLC1VampireDrain08         	Auto
Spell	Property DLC1VampireDrain09         	Auto
Spell	Property VampireRaiseDeadLeftHand01		Auto
Spell	Property VampireRaiseDeadLeftHand02		Auto
Spell	Property VampireRaiseDeadLeftHand03		Auto
Spell	Property VampireRaiseDeadLeftHand04		Auto
Spell	Property VampireRaiseDeadLeftHand05		Auto
Spell	Property VampireLordEnhancements		Auto
Spell	Property VampireLvl10AndBelowAb  		Auto
Spell	Property VampireLvl15AndBelowAb  		Auto
Spell	Property VampireLvl20AndBelowAb  		Auto
Spell	Property VampireLvl25AndBelowAb  		Auto
Spell	Property VampireLvl30AndBelowAb  		Auto
Spell	Property VampireLvl35AndBelowAb  		Auto
Spell	Property VampireLvl40AndBelowAb  		Auto
Spell	Property VampireLvl45AndBelowAb  		Auto
Spell	Property VampireLvl50AndOverAb   		Auto
Spell	Property VampireLordSunDamage    		Auto

; Vampire Lord Transform Support
Spell		Property VampireLordChange			Auto
Race		Property VampireLordRace			Auto
Armor		Property VampireLordArmor			Auto
Armor		Property VampireLordCape			Auto
Idle		Property VampireLordFeed			Auto
Idle		Property NormalVampireFeed			Auto
Idle		Property VampireTransformation		Auto
Explosion	Property VampChangeExplosion		Auto
Spell		Property VampireChangeStagger		Auto
Ammo		Property DLC1ElderScrollBack		Auto

; Outfits and clothes
Outfit		Property SerenaOutfit				Auto
Armor		Property ArmorVampireArmorRoyal		Auto
Armor		Property ArmorVampireBoots			Auto

; locations
Location	Property VolkiharKeep				Auto
Location	Property FortDawnguard				Auto
Location	Property ForgottenVale				Auto
Location	Property VolkiharExterior			Auto
Location	Property VolkiharUndercroft			Auto
Location	Property SoulCairn					Auto

; textures
TextureSet	Property VampireEyes				Auto
Int			Property Eye_Num					Auto

; Globals
GlobalVariable Property IntroCompletedVampire 	Auto
GlobalVariable Property IntroCompletedHunter 	Auto

; Bug Fixes
Quest			Property SeranaCureSelfQuest	Auto
GlobalVariable	Property HarkonDead 			Auto
GlobalVariable	Property MomRescued				Auto
Armor			Property SeranaHood				Auto

; AFT
GlobalVariable Property pGameDaysPassed  Auto  

Bool		Property EnteredVolkihar			Auto
Float 		Property version 					Auto

Race		Property ArgonianRace				Auto
Race		Property KhajiitRace				Auto

Spell		Property ABVampireSkills			Auto

Faction		Property TweakHasVLGift					Auto
Faction		Property TweakNoAI						Auto
Faction		Property VampireLordFaction				Auto
Faction 	Property TweakPotentialFollowerFaction	Auto
Faction		Property TweakIgnoreFaction				Auto
Faction		Property pPotentialFollowerFaction		Auto  
Faction		Property pDismissedFollowerFaction		Auto  
Faction 	Property TweakManagedInventoryFaction	Auto
Faction 	Property TweakPosedFaction				Auto
Faction 	Property TweakHangoutFaction			Auto

Faction 	Property TweakRescueMom					Auto
Faction 	Property TweakSoulCairn					Auto
Faction 	Property TweakUseVampireFaction  		Auto  
Faction 	Property TweakAlwaysVampireFaction 		Auto
Faction 	Property TweakCSVampireFaction 			Auto
Faction 	Property TweakPTVampireFaction 			Auto
Faction 	Property TweakHDVampireFaction 			Auto

TextureSet	Property SkinEyesMaleArgonianVampire	Auto
TextureSet	Property SkinEyesFemaleArgonianVampire	Auto
TextureSet	Property SkinEyesKhajiitVampire			Auto
TextureSet	Property EyesMaleHumanVampire			Auto

TweakDFScript 		Property pTweakDFScript			Auto
TweakFollowerScript Property pTweakFollowerScript	Auto
ReferenceAlias		Property pFollower				Auto

Event OnInit()

	EnteredVolkihar		= false
	Installed			= false
	version				= 1.2
	AllToNone()

endEvent

Bool Function initializeSpellMap()

	if (!installed)
		SpellMap		= new Spell[16] 
		SpellNames		= new String[16]
		SpellCosts		= new Int[16]
		SpellSchools	= new Int[16]
	endif
	
	if (1.0 == version)
		version = 1.1
		SpellSchools	= new Int[16]
	endif

	if (1.1 == version)
		version = 1.2
		SpellMap		= new Spell[16]
		SpellNames		= new String[16]
		SpellCosts		= new Int[16]
		SpellSchools	= new Int[16]
	endif

	; Schools
	; -1 = None
	; 0 = Alteration 
	; 1 = Conjuration 
	; 2 = Destruction 
	; 3 = Illusion 
	; 4 = Restoration

	SpellNames[0]	= "{[}"
	SpellMap[0]		= Game.GetFormFromFile(0x020045BA,"Dawnguard.esm") As Spell
	SpellCosts[0]	= 129
	SpellSchools[0]	= 1
	SpellNames[1]	= "~Xg}"
	SpellMap[1]		= Game.GetFormFromFile(0x020045B8,"Dawnguard.esm") As Spell
	SpellCosts[1]	= 193
	SpellSchools[1]	= 1
	SpellNames[2]	= "X}"
	SpellMap[2]		= Game.GetFormFromFile(0x020045B3,"Dawnguard.esm") As Spell
	SpellCosts[2]	= 301
	SpellSchools[2]	= 1
	SpellNames[3]	= "Afbh̎"
	SpellMap[3]		= Game.GetFormFromFile(0x0200E8D4,"Dawnguard.esm") As Spell
	SpellCosts[3]	= 115
	SpellSchools[3]	= 4
	SpellNames[4]	= "p"
	SpellMap[4]		= Game.GetFormFromFile(0x0200E8D2,"Dawnguard.esm") As Spell
	SpellCosts[4]	= 37
	SpellSchools[4]	= 4
	SpellNames[5]	= "Xe_[̃I["
	SpellMap[5]		= Game.GetFormFromFile(0x020038B5,"Dawnguard.esm") As Spell
	SpellCosts[5]	= 248
	SpellSchools[5]	= 4
	SpellNames[6]	= "z̉"
	SpellMap[6]		= Game.GetFormFromFile(0x02003F52,"Dawnguard.esm") As Spell
	SpellCosts[6]	= 24
	SpellSchools[6]	= 0
	SpellNames[7]	= "z̉()"
	SpellMap[7]		= Game.GetFormFromFile(0x02010D8D,"Dawnguard.esm") As Spell
	SpellCosts[7]	= 34
	SpellSchools[7]	= 4
	SpellNames[8]	= "zS̃xC"
	SpellMap[8]		= Game.GetFormFromFile(0x020038B6,"Dawnguard.esm") As Spell
	SpellCosts[8]	= 72
	SpellSchools[8]	= 4
	SpellNames[9]	= "厡"
	SpellMap[9]		= Game.GetFormFromFile(0x020122B8,"Dawnguard.esm") As Spell
	SpellCosts[9]	= 43
	SpellSchools[9]	= 4
	SpellNames[10]	= "zS̎"
	SpellMap[10]	= Game.GetFormFromFile(0x020038B7,"Dawnguard.esm") As Spell
	SpellCosts[10]	= 64
	SpellSchools[10]= 0
	SpellNames[11]	= "ACXXpCN(E)"
	SpellMap[11]	= Game.GetFormFromFile(0x02014CC5,"Dawnguard.esm") As Spell
	SpellCosts[11]	= 48
	SpellSchools[11]= 2
	SpellNames[12]	= "ACXXg[(E)"
	SpellMap[12]	= Game.GetFormFromFile(0x02014CC6,"Dawnguard.esm") As Spell
	SpellCosts[12]	= 144
	SpellSchools[12]= 2
	SpellNames[13]	= "HS쐬(E)"
	SpellMap[13]	= Game.GetFormFromFile(0x02011F35,"Dawnguard.esm") As Spell
	SpellCosts[13]	= 77
	SpellSchools[13]= 1
	SpellNames[14]	= "쐬"
	SpellMap[14]	= Game.GetFormFromFile(0x0200A270,"Dawnguard.esm") As Spell
	SpellCosts[14]	= 0
	SpellSchools[14]= 1
	SpellNames[15]	= "A@N"
	SpellMap[15]	= Game.GetFormFromFile(0x0200C600,"Dawnguard.esm") As Spell
	SpellCosts[15]	= 136
	SpellSchools[15]= 1


	int i = 0
	while i < SpellMap.length
		if (!SpellMap[i])
			return false
		endif
		i += 1
	EndWhile
	return true

EndFunction

Function OnGameLoaded()

	DLC1NPCMentalModel = Game.GetFormFromFile(0x02002B6E,"Dawnguard.esm") As Quest
	
	if (DLC1NPCMentalModel)
		; DawnGuard Detected		

		bool 	issue = false

		; Load Resources
		SerenaBase = Game.GetFormFromFile(0x02002B6C,"Dawnguard.esm") As ActorBase
		SerenaRef = DLC1NPCMentalModel.GetAlias(0) As ReferenceAlias
		Serena = SerenaRef.GetActorRef()
		if !Serena
			Serena = (Game.GetFormFromFile(0x02002B74,"Dawnguard.esm") As ObjectReference) As Actor
		endif

		if (SerenaBase && SerenaRef && Serena)
			if (!installed)
				Serena.AddToFaction(TweakPotentialFollowerFaction)
				Serena.AddToFaction(TweakHasVLGift)
				if (0 != Serena.GetActorValue("FavorActive") As Int)
					if (Serena.IsPlayerTeammate())
						SerenaFollow(SerenaRef.GetRef())
					endif
				endif
			endif
		else
			issue = true
		endif

		TrollFollowerBase	= Game.GetFormFromFile(0x020117F1,"Dawnguard.esm") As ActorBase
		if (!TrollFollowerBase)
			issue = True
		endif
				
		; Load Vampire Abilities
		ConjureGargoyleLeftHand = Game.GetFormFromFile(0x020045B3,"Dawnguard.esm") As Spell
		CorpseCurseLeftHand 	= Game.GetFormFromFile(0x02008A6F,"Dawnguard.esm") As Spell
		MastersGaze 			= Game.GetFormFromFile(0x020038BB,"Dawnguard.esm") As Spell

		if (!ConjureGargoyleLeftHand || !CorpseCurseLeftHand || !MastersGaze )
			issue = True
		endif

		; NOTE: These are still here because of a mistake (so that people upgrading can have
		; the spells removed) However, the drain 05-09 spells should NOT be added to followers 
		; as these spells assume the player is casting them.

		DLC1VampireDrain05		= Game.GetFormFromFile(0x02019324,"Dawnguard.esm") As Spell
		DLC1VampireDrain06		= Game.GetFormFromFile(0x02019326,"Dawnguard.esm") As Spell
		DLC1VampireDrain07		= Game.GetFormFromFile(0x02019AD5,"Dawnguard.esm") As Spell
		DLC1VampireDrain08		= Game.GetFormFromFile(0x02019AD6,"Dawnguard.esm") As Spell
		DLC1VampireDrain09		= Game.GetFormFromFile(0x02019AD7,"Dawnguard.esm") As Spell

		if (!DLC1VampireDrain05 || !DLC1VampireDrain06 || !DLC1VampireDrain07 )
			issue = True
		endif

		if (!DLC1VampireDrain08 || !DLC1VampireDrain09)
			issue = True
		endif
				
		VampireRaiseDeadLeftHand01	= Game.GetFormFromFile(0x0200BA54,"Dawnguard.esm") As Spell
		VampireRaiseDeadLeftHand02	= Game.GetFormFromFile(0x02013EC8,"Dawnguard.esm") As Spell
		VampireRaiseDeadLeftHand03	= Game.GetFormFromFile(0x02013EC9,"Dawnguard.esm") As Spell
		VampireRaiseDeadLeftHand04	= Game.GetFormFromFile(0x02013ECA,"Dawnguard.esm") As Spell
		VampireRaiseDeadLeftHand05	= Game.GetFormFromFile(0x02013ECB,"Dawnguard.esm") As Spell
		VampireLordEnhancements		= Game.GetFormFromFile(0x0201462A,"Dawnguard.esm") As Spell

		if (!VampireRaiseDeadLeftHand01 || !VampireRaiseDeadLeftHand02)
			issue = True
		endif
		if (!VampireRaiseDeadLeftHand03 || !VampireRaiseDeadLeftHand04)
			issue = True
		endif
		if (!VampireRaiseDeadLeftHand05 || !VampireLordEnhancements)
			issue = True
		endif
				
		VampireLvl10AndBelowAb	= Game.GetFormFromFile(0x02007A36,"Dawnguard.esm") As Spell
		VampireLvl15AndBelowAb	= Game.GetFormFromFile(0x02007A37,"Dawnguard.esm") As Spell
		VampireLvl20AndBelowAb	= Game.GetFormFromFile(0x02007A38,"Dawnguard.esm") As Spell
		VampireLvl25AndBelowAb	= Game.GetFormFromFile(0x02007A39,"Dawnguard.esm") As Spell
		VampireLvl30AndBelowAb	= Game.GetFormFromFile(0x02007A3A,"Dawnguard.esm") As Spell
		VampireLvl35AndBelowAb	= Game.GetFormFromFile(0x02007A3B,"Dawnguard.esm") As Spell
		VampireLvl40AndBelowAb	= Game.GetFormFromFile(0x02007A3C,"Dawnguard.esm") As Spell
		VampireLvl45AndBelowAb	= Game.GetFormFromFile(0x02007A3D,"Dawnguard.esm") As Spell
		VampireLvl50AndOverAb	= Game.GetFormFromFile(0x02007A3E,"Dawnguard.esm") As Spell
		VampireLordSunDamage	= Game.GetFormFromFile(0x02012D15,"Dawnguard.esm") As Spell
		
		if (!VampireLvl10AndBelowAb || !VampireLvl15AndBelowAb || !VampireLvl20AndBelowAb)
			issue = True
		endif
		if (!VampireLvl25AndBelowAb || !VampireLvl30AndBelowAb || !VampireLvl35AndBelowAb)
			issue = True
		endif
		if (!VampireLvl40AndBelowAb || !VampireLvl45AndBelowAb || !VampireLvl50AndOverAb)
			issue = True
		endif				
		if (!VampireLordSunDamage)
			issue = True
		endif				
				
		; Vampire Lord Transform
		
		; 3B has a condition on it that only allows it to work when the player is not already 
		; in vampire lord form, but it the spell that is given to the Player. We need to 
		; load it in order to detect when the player has become a VL
		
		; 3D bypasses the check, we were still having instability issues with VL Mages, so 
		; we just roll our own. 
		; VampireLordChange 	= Game.GetFormFromFile(0x0200283B,"Dawnguard.esm") As Spell

		VampireLordChange 	= Game.GetFormFromFile(0x0200283B,"Dawnguard.esm") As Spell
		VampireLordRace		= Game.GetFormFromFile(0x0200283A,"Dawnguard.esm") As Race
		DLC1ElderScrollBack = Game.GetFormFromFile(0x0201A958,"Dawnguard.esm") As Ammo
		
		if (!VampireLordRace || !VampireLordChange || !DLC1ElderScrollBack)
			issue = true
		endif

		VampireLordArmor	= Game.GetFormFromFile(0x02011A84,"Dawnguard.esm") As Armor
		VampireLordCape		= Game.GetFormFromFile(0x02015BC1,"Dawnguard.esm") As Armor

		if (!VampireLordArmor || !VampireLordCape)
			issue = true
		endif
		
		VampireLordFeed		= Game.GetFormFromFile(0x02017638,"Dawnguard.esm") As Idle
		NormalVampireFeed	= Game.GetFormFromFile(0x0200E6A8,"Dawnguard.esm") As Idle

		if (!VampireLordFeed || !NormalVampireFeed)
			issue = true
		endif

		VampireTransformation		= Game.GetFormFromFile(0x0200C61D,"Dawnguard.esm") As Idle
		VampChangeExplosion			= Game.GetFormFromFile(0x02015373,"Dawnguard.esm") As Explosion
		VampireChangeStagger		= Game.GetFormFromFile(0x02012D18,"Dawnguard.esm") As Spell

		if (!VampireTransformation || !VampChangeExplosion || !VampireChangeStagger)
			issue = true
		endif
		
		; Outfits and Clothes
		SerenaOutfit				= Game.GetFormFromFile(0x02016903,"Dawnguard.esm") As Outfit
		ArmorVampireArmorRoyal		= Game.GetFormFromFile(0x0200B5DB,"Dawnguard.esm") As Armor
		ArmorVampireBoots			= Game.GetFormFromFile(0x0200B5DE,"Dawnguard.esm") As Armor
		if (!SerenaOutfit || !ArmorVampireArmorRoyal || !ArmorVampireBoots)
			issue = True
		endif

		; Locations
		VolkiharKeep				= Game.GetFormFromFile(0x0200357D,"Dawnguard.esm") As Location
		FortDawnguard				= Game.GetFormFromFile(0x020128FE,"Dawnguard.esm") As Location
		ForgottenVale				= Game.GetFormFromFile(0x0200A87C,"Dawnguard.esm") As Location

		if (!VolkiharKeep || !FortDawnguard || !ForgottenVale)
			issue = True
		endif

		VolkiharExterior			= Game.GetFormFromFile(0x02004C20,"Dawnguard.esm") As Location
		VolkiharUndercroft			= Game.GetFormFromFile(0x0200357E,"Dawnguard.esm") As Location
		SoulCairn					= Game.GetFormFromFile(0x02003B8F,"Dawnguard.esm") As Location

		if (!VolkiharExterior || !VolkiharUndercroft || !SoulCairn)
			issue = True
		endif

		; Textures
		VampireEyes					= Game.GetFormFromFile(0x02006F89,"Dawnguard.esm") As TextureSet 
		if (!VampireEyes)
			issue = True
		endif
				
		; Globals
		IntroCompletedVampire		= Game.GetFormFromFile(0x020141A3,"Dawnguard.esm") As GlobalVariable
		IntroCompletedHunter		= Game.GetFormFromFile(0x020141A4,"Dawnguard.esm") As GlobalVariable
		if (!IntroCompletedVampire || !IntroCompletedHunter)
			issue = True
		endif
		
		; Bug Fixes
		SeranaCureSelfQuest			= Game.GetFormFromFile(0x02005044,"Dawnguard.esm") As Quest
		HarkonDead					= Game.GetFormFromFile(0x02015A20,"Dawnguard.esm") As GlobalVariable
		MomRescued					= Game.GetFormFromFile(0x02015A22,"Dawnguard.esm") As GlobalVariable
		SeranaHood					= Game.GetFormFromFile(0x0200E6A0,"Dawnguard.esm") As Armor
		
		if (!SeranaCureSelfQuest || !HarkonDead || !MomRescued || !SeranaHood)
			issue = True
		endif
		
		if (!initializeSpellMap())
			issue = True
		endif
				
		if (issue)
			Debug.MessageBox("AFT:DawnGuard̃C|[gɎsB̉\")
		elseif (!Installed)
			if (pGameDaysPassed.GetValue() > 1)
				Debug.Notification("AFT : DawnGuard Resources Imported Successfully")
			endif
			Installed = true
		endif
		
	elseIf (Installed)

		Debug.MessageBox("AFT:Dawnguard̓ǂݍ݂~")
		; Unload Resources
		AllToNone()
		Installed = false
	endIf
	
endFunction

Function AllToNone()

		; Actors and Quests
		SerenaBase              = None
		SerenaRef               = None
		Serena					= None
		TrollFollowerBase		= None
		DLC1NPCMentalModel		= None

		; Vampire Abilities
		ConjureGargoyleLeftHand = None
		CorpseCurseLeftHand 	= None
		MastersGaze 			= None
		DLC1VampireDrain05		= None
		DLC1VampireDrain06		= None
		DLC1VampireDrain07		= None
		DLC1VampireDrain08		= None
		DLC1VampireDrain09		= None
		VampireRaiseDeadLeftHand01	= None
		VampireRaiseDeadLeftHand02	= None
		VampireRaiseDeadLeftHand03	= None
		VampireRaiseDeadLeftHand04	= None
		VampireRaiseDeadLeftHand05	= None
		VampireLordEnhancements		= None
		VampireLvl10AndBelowAb	= None
		VampireLvl15AndBelowAb	= None
		VampireLvl20AndBelowAb	= None
		VampireLvl25AndBelowAb	= None
		VampireLvl30AndBelowAb	= None
		VampireLvl35AndBelowAb	= None
		VampireLvl40AndBelowAb	= None
		VampireLvl45AndBelowAb	= None
		VampireLvl50AndOverAb	= None
		VampireLordSunDamage	= None
		
		; Vampire Lord Transform Support
		VampireLordChange 		= None
		VampireLordRace			= None
		DLC1ElderScrollBack		= None
		VampireLordArmor		= None
		VampireLordCape			= None
		NormalVampireFeed		= None
		VampireLordFeed			= None
		VampireTransformation	= None
		VampChangeExplosion		= None
		VampireChangeStagger	= None

		; Outfits and clothes
		SerenaOutfit			= None
		ArmorVampireArmorRoyal	= None
		ArmorVampireBoots		= None

		; Locations
		VolkiharKeep			= None
		FortDawnguard			= None
		ForgottenVale			= None
		VolkiharExterior		= None
		VolkiharUndercroft		= None
		SoulCairn				= None

		; Textures
		VampireEyes				= None

		; Globals
		IntroCompletedVampire	= None
		IntroCompletedHunter	= None
		
		; Bug Fixes
		SeranaCureSelfQuest		= None
		HarkonDead				= None
		MomRescued				= None
		SeranaHood				= None
		
		int i = 0
		while i < SpellMap.length
			SpellMap[i] = None
			i += 1
		EndWhile

endFunction

Function v165Update()
	if (Serena)
		if (0 != Serena.GetActorValue("FavorActive") As Int)
			if (Serena.IsPlayerTeammate())
				if (SerenaRef)
					pFollower.ForceRefTo(SerenaRef.GetRef())
				endif
			EndIf
		endif
	endif
EndFunction

Function TransformVL(Actor Target)

	if (Target.GetActorBase().GetRace() != VampireLordRace)
		Target.PlayIdle(VampireTransformation) ; This is not async
		Utility.Wait(2.25)
		TransformNow(Target)
	endif
	
EndFunction

Function TransformNow(Actor Target)

	if (Target == None)
		return
	endif

	Actor pc = Game.GetPlayer()
	if (Target == pc)
		return
	endif

	Race currRace = Target.GetRace()

	if (currRace != VampireLordRace)
		if (Target == Serena)
			Target.UnequipItem(DLC1ElderScrollBack)
			Utility.wait(0.1)
			; Target.RemoveItem(DLC1ElderScrollBack)
		endif

		Target.SetRace(VampireLordRace)
		Target.placeatme(VampChangeExplosion)

		if (Target.GetDistance(pc) < 300)
			utility.Wait(0.33)
			Game.TriggerScreenBlood(5)
			utility.Wait(0.1)
			Game.TriggerScreenBlood(10)
		endif

		Target.AddItem(VampireLordArmor, 1, True)
		Target.EquipItem(VampireLordArmor,  True, True)
		if (Target == Serena)
			Target.AddItem(VampireLordCape, 1, True)
			Target.EquipItem(VampireLordCape,  True, True)
			Utility.wait(0.1)
			Target.UnequipItem(DLC1ElderScrollBack)
		EndIf
	endif

endFunction

; Called From TweakMonitorPlayer dialogue monitor
Function OnDialogueBegin(ObjectReference ActorRef)

	; Need to Add Dawnguard Dogs to TweakIgnore Faction, Else
	; player gets double dialogues. 
	
;	Actor npc = ActorRef As Actor
;	if (!npc)
;		return
;	endif
;	ActorBase base = npc.GetActorBase()
;	if (base == TrollFollowerBase)
;		; TrollFollowerBase is a leveled actor... we need a non-leveled actor to Add
;		; dialogue, so we spawn a copy. 
;		
;		; Todo: Race check to make sure we spawn the correct troll. 
;		ActorBase DLCFrostTrollBase = Game.GetFormFromFile(0x0201981E,"Dawnguard.esm") As ActorBase
;		Game.GetPlayer().PlaceAtMe(DLCFrostTrollBase)
;	endIf

EndFunction

Function OnDialogueEnd(ObjectReference ActorRef)
;	Actor npc = ActorRef As Actor
;	if (!npc)
;		return
;	endif
;	ActorBase base = npc.GetActorBase()
;	if (base == SerenaBase)
;		if (npc.IsInFaction(TweakIgnoreFaction))
;			npc.RemoveFromFaction(TweakIgnoreFaction)
;		endif
;	endif
EndFunction

Function SerenaFollow(ObjectReference FollowerRef = None)

	Quest DLC1NPCMonitoringPlayer = Game.GetFormFromFile(0x02003BC0,"Dawnguard.esm") As Quest
	if (DLC1NPCMonitoringPlayer && DLC1NPCMonitoringPlayer.IsRunning())
		; No need for this as AFT provides better management
		DLC1NPCMonitoringPlayer.Stop()
		; Wait more than 1 second to give Monitor time to finish last poll
		Utility.wait(1.5)
	endif

	Serena.RemoveFromFaction(pPotentialFollowerFaction)
	if (!Serena.IsInFaction(pDismissedFollowerFaction))
		if (!Serena.HasSpell(ABVampireSkills))
			Serena.AddSpell(ABVampireSkills)
		endif
		; First time
		; if (0 == Serena.GetItemCount(ArmorVampireArmorRoyal))
		; 	Serena.EquipItem(ArmorVampireArmorRoyal)
		; endif
		; if (0 == Serena.GetItemCount(ArmorVampireBoots))
		; 	Serena.EquipItem(ArmorVampireBoots)
		; endif
	endif
	if (Serena.IsInFaction(TweakIgnoreFaction))
		Serena.RemoveFromFaction(TweakIgnoreFaction)
	endif
	if FollowerRef
		pFollower.ForceRefTo(FollowerRef)
	endif

EndFunction

Function SerenaDismiss(ObjectReference FollowerRef = None)

	pFollower.Clear()

EndFunction

Function Embrace(ObjectReference actorRef)
	if (!Installed)
		return
	endIf
	Actor npc = actorRef as Actor
	if (!npc)
		return
	endif
	if (npc.GetActorBase() == SerenaBase)
		; Free up cure alias behaviors...
		if (SeranaCureSelfQuest.IsRunning())
			SeranaCureSelfQuest.Stop()
		endif
		; Re-Add Vampire Spells and Keywords
		ReferenceAlias VampireSpellsAndKeywords = DLC1NPCMentalModel.GetAlias(3) As ReferenceAlias
		if (VampireSpellsAndKeywords)
			VampireSpellsAndKeywords.ForceRefTo(npc)
		endif
		Serena.AddToFaction(TweakHasVLGift)
	endif
	; Fix the eyes
	SetVampireEyes(npc)
EndFunction

Function SetVampireEyes(Actor npc)
	
	; Todo: Argonian and Khajiit need different eyes.
	if (npc.GetRace() == ArgonianRace)
		if (1 == npc.GetActorBase().GetSex())
			npc.SetEyeTexture(SkinEyesFemaleArgonianVampire)
		else
			npc.SetEyeTexture(SkinEyesMaleArgonianVampire)
		endif
	elseif (npc.GetRace() == KhajiitRace)
		npc.SetEyeTexture(SkinEyesKhajiitVampire)
	elseif (installed && VampireEyes && npc == Serena)
		npc.SetEyeTexture(VampireEyes)
	else
		npc.SetEyeTexture(EyesMaleHumanVampire)
	endif
EndFunction


Function OnChangeLocation(Location akNewLocation)
	
	if (!Installed)
		return
	endIf

	Actor pc = Game.GetPlayer()

;	String msg = "Location [" + akNewLocation + "]\n"
;	msg += "Loc ID [" + akNewLocation.GetFormID() + "]\n"
;	Cell pCell2 = pc.GetParentCell()
;	msg += "Cell [" + pCell2 + "]\n"
;	msg += "Cel ID [" + pCell2.GetFormID() + "]\n"
;	Debug.MessageBox(msg)

	if (pc.HasSpell(VampireLordChange))
		PlayerIsLord = True
	else
		PlayerIsLord = False
	endif

	; Bug Fix Checks
	if (0.0 != HarkonDead.GetValue())
		if (0.0 != MomRescued.GetValue())
			if Serena.IsInFaction(TweakRescueMom)
				Serena.RemoveFromFaction(TweakRescueMom)
			endif
			Serena.AddToFaction(TweakSoulCairn)
		Else
			Serena.AddToFaction(TweakRescueMom)
		EndIf
		if (SeranaCureSelfQuest.IsRunning() && SeranaCureSelfQuest.GetStage() == 200)
			Serena.RemoveFromFaction(TweakHasVLGift)
			Serena.RemoveFromFaction(TweakUseVampireFaction)
			Serena.RemoveFromFaction(TweakAlwaysVampireFaction)
			Serena.RemoveFromFaction(TweakCSVampireFaction)
			Serena.RemoveFromFaction(TweakPTVampireFaction)
			Serena.RemoveFromFaction(TweakHDVampireFaction)
		endif
	endif
	
	if (!akNewLocation)
		return
	endif
	
	; There are some Serena scenarios that slip through. Like: Drop Serena off at dads and then update AFT.
	; The ignore faction wont be set if you are siding with Dawnguard. However this simply avoids extra AFT 
	; related responses in conversation that precedes the end of the introduction. It isn't a game breaker. 
	; We would have to understand the various quests and stages that lead to the transition to capture
	; all scenarios, and I dont feel like coding that much. 

	if ((IntroCompletedVampire.GetValueInt() == 0) && (IntroCompletedHunter.GetValueInt() == 0))
		if (akNewLocation == VolkiharKeep)
			if (!EnteredVolkihar)
				EnteredVolkihar = true
				SerenaRelease()
				
				int max = 5
				While(FALSE == Serena.Is3DLoaded() && max > 0)
					Utility.wait(0.25)
					max -= 1
				EndWhile
				Utility.wait(0.25)

				; DismissFollower will bail if she is not being managed
				pTweakDFScript.DialogueRef = Serena
				pTweakDFScript.DismissFollower(-1,0)
			endif
			; We add her to the ignore faction even if she is not managed So
			; that user can not begin managing her during intro (causes clothing issues)
			Serena.AddToFaction(TweakIgnoreFaction)
		endif
	elseif (Serena.IsPlayerTeammate() && Serena.IsInFaction(TweakIgnoreFaction))
		Serena.RemoveFromFaction(TweakIgnoreFaction)
	endif

	if (0 == Serena.GetAV("FavorActive"))
		return
	endif

	if (Serena.IsPlayerTeammate() && Serena.IsInFaction(TweakNoAI))
		Serena.RemoveFromFaction(TweakNoAI)
	endif

	if (akNewLocation.GetFormID() < 0x01000000)
		return
	endif

	bool noFollowerZone = false
	if (akNewLocation == VolkiharUndercroft || akNewLocation == SoulCairn)
		noFollowerZone = true
	elseif (akNewLocation == VolkiharExterior)
		Cell pCell = pc.GetParentCell()
		int max = 4
		while (!pCell && max > 0)
			Utility.wait(0.50)
			pCell = pc.GetParentCell()
			max -= 1
		endWhile
		if (pCell)
			; You have to wait for the Parent Location to load 
			; before extracting a cell from a resouce or it will fail
			Cell theCourtYard = Game.GetFormFromFile(0x0200721D,"Dawnguard.esm") As Cell
			if (theCourtYard == pCell)
				noFollowerZone = true
			endif
		endif
	endif
	
	if (noFollowerZone)
		Serena.AddToFaction(TweakNoAI)		
		Float[] behindMe=pTweakFollowerScript.TraceCircle(pc, 100, -180)
		Serena.SetPosition(behindMe[0],behindMe[1], behindMe[2])
		Serena.SetAngle(0.0,0.0, (pc.GetAngleZ()))
	endif
	
	; Cut Scenes override normal AI. Every 15 seconds when cutscene AI polls, it Will
	; Have follower remove clothes if their outfit is not being managed. 
	;
	; Fight with Snow Elf Boss has cut scene. If Serena has been posed or dismissed in some
	; way, she will show up naked and get stuck after cut scene. So when we enter the cell, 
	; we release Serena and make her a current follower. If her Standard Outfit is Not
	; currently enabled, we take a silent snapshot. 

	if (akNewLocation == ForgottenVale)
		Cell pCell = pc.GetParentCell()
		int max = 4
		while (!pCell && max > 0)
			Utility.wait(0.50)
			pCell = pc.GetParentCell()
			max -= 1
		endWhile
		if (pCell)
			; You have to wait for the Parent Location to load 
			; before extracting a cell from a resouce or it will fail

			Cell theTemple = Game.GetFormFromFile(0x02000CE4,"Dawnguard.esm") As Cell
			if (theTemple == pCell)	
				SerenaRelease()
				if (Serena.IsInFaction(TweakManagedInventoryFaction))
					; SetFollower will bail if she is already managed
					pTweakDFScript.SetFollower(Serena)
				else
					max = 5
					While(FALSE == Serena.Is3DLoaded() && max > 0)
						Utility.wait(0.25)
						max -= 1
					EndWhile
					Utility.wait(0.25)

					; DismissFollower will bail if she is not being managed
					pTweakDFScript.DialogueRef = Serena
					pTweakDFScript.DismissFollower(-1,0)
				endif
			endif
		endif
	endif

EndFunction

Function SerenaRelease()

	Actor pc = Game.GetPlayer()

	; Just in case...
	if (Serena.isUnconscious())
		Serena.SetUnconscious(FALSE)
	endif
	Serena.EnableAI(true)

	if Serena.IsInFaction(TweakPosedFaction)			; Stop Hangout if in effect
		pTweakFollowerScript.PreparePose(Serena)		; Stop pose if running
	endif
	if Serena.IsInFaction(TweakHangoutFaction)			; Stop Hangout if in effect
		Serena.RemoveFromFaction(TweakHangoutFaction)
	endif
	if (57339 == (Serena.GetAv("Infamy") as Int))		; Disable ForceSleep
		Serena.SetAv("infamy",0)
	endif
	Serena.SetAV("WaitingForPlayer", 0) 				; Disable Wait

	; Move her to player and make sure her model is loaded or
	; dismiss may cause her to become naked.

	Serena.MoveToIfUnloaded(pc)
	Float[] behindMe=pTweakFollowerScript.TraceCircle(pc, 175, -150)
	Serena.SetPosition(behindMe[0],behindMe[1], behindMe[2])
	Serena.SetAngle(0.0,0.0, (pc.GetAngleZ()))

EndFunction

Function GotoMom()
    ObjectReference ValericaMarker = Game.GetFormFromFile(0x02003B95,"Dawnguard.esm") As ObjectReference
	Game.GetPlayer().MoveTo(ValericaMarker)
	Serena.MoveTo(ValericaMarker)
EndFunction

Function GotoSoulCairn()
    ObjectReference SoulCairnMarker = Game.GetFormFromFile(0x02008391,"Dawnguard.esm") As ObjectReference
	Game.GetPlayer().MoveTo(SoulCairnMarker)
	Serena.MoveTo(SoulCairnMarker)
EndFunction

Function AftReset()
	if (installed)
		Debug.MessageBox("AFT:Dawnguard̓ǂݍ݂~")
		pTweakDFScript.DialogueRef = Serena
		pTweakDFScript.DismissFollower(-1,0)
		Serena.RemoveFromFaction(pDismissedFollowerFaction)	
		Serena.RemoveFromFaction(TweakIgnoreFaction)

		Installed = false
		PlayerIsLord = false
		AllToNone()

		Quest DLC1NPCMonitoringPlayer = Game.GetFormFromFile(0x02003BC0,"Dawnguard.esm") As Quest
		if (DLC1NPCMonitoringPlayer && !DLC1NPCMonitoringPlayer.IsRunning())
			; Restart DawnGuards Serana AI
			DLC1NPCMonitoringPlayer.Start()
		endif
	endif
EndFunction

int Function GetSpellIndex(Spell theSpell)
	Form formRef = theSpell As Form
	Form spellRef

	int i = 0
	while(i < 16)
		spellRef = SpellMap[i]
		if (spellRef == formRef)
			return i
		endif
		i = i + 1
	endWhile
	return -1

EndFunction

String Function GetSpellName(int index)
	return SpellNames[index]
endFunction 

Int Function GetSpellCost(int index)
	return SpellCosts[index]
endFunction 

Int Function GetSpellSchool(int index)
	return SpellSchools[index]
endFunction 
