Scriptname TweakFollowerSpells extends Quest  Conditional

; Spells
FormList Property TweakSpellList Auto
FormList Property TweakSummonSpells  Auto  
FormList Property TweakPCTargetSpells  Auto  
FormList Property TweakSelfTargetSpells  Auto  

Bool Property DisableMagicHintOnce Auto
Bool Property ViewTeachHintOnce Auto
Bool Property ViewTeachCombatHintOnce Auto
Bool Property AddSetHintOnce Auto
Bool Property ClearHintOnce Auto

SPELL Property VampireDrain01  Auto  
SPELL Property VampireDrain02  Auto  
SPELL Property VampireDrain03  Auto  
SPELL Property VampireDrain04  Auto  
SPELL Property VampireCharm  Auto  
SPELL Property dunHighGateSummonFlamingThrall  Auto  

TweakFollowerScript Property pTweakFollowerScript Auto
TweakDawnGuardScript Property pTweakDawnGuardScript Auto
TweakDragonBornScript Property pTweakDragonBornScript Auto

String[] Property SpellNamesA Auto
String[] Property SpellNamesB Auto
Int[] Property SpellCostsA Auto
Int[] Property SpellCostsB Auto
Int[] Property SpellSchoolsA Auto
Int[] Property SpellSchoolsB Auto

FormList Property TweakCustomSpells Auto

Message Property TweakLSpellConfirm Auto
Message Property TweakRSpellConfirm Auto
Message Property TweakSpellType Auto
Message Property TweakSpellWhenBuff Auto
Message Property TweakSpellWhenAttack Auto
Message Property TweakSpellCriteria Auto

GlobalVariable Property pTweakThreadCount Auto

; Utility
FormList Property TweakEmptyList Auto

; Conditionals used to support Button options in the Message Properties above
Bool Property isEnemyOption Auto Conditional
TweakTMScript Property pTweakTMScript Auto

Event OnInit()
	DisableMagicHintOnce=false
	ViewTeachHintOnce=false
	ViewTeachCombatHintOnce=false
	AddSetHintOnce=false
	ClearHintOnce=false
endEvent

; Called From TweakFollowerScript (So we can centralize version management)
Function initializeSpellMaps()

	SpellNamesA = new String[128]
	SpellCostsA = new Int[128]

	SpellNamesA[0] = "AfbhxC"
	SpellCostsA[0] = 988
	SpellNamesA[1] = "fChA"
	SpellCostsA[1] = 196
	SpellNamesA[2] = "fChA()"
	SpellCostsA[2] = 196
	SpellNamesA[3] = "uU[h"
	SpellCostsA[3] = 1106
	SpellNamesA[4] = "̗͂蕀"
	SpellCostsA[4] = 168
	SpellNamesA[5] = "͂̋|"
	SpellCostsA[5] = 206
	SpellNamesA[6] = "͂̌"
	SpellCostsA[6] = 92
	SpellNamesA[7] = "͂̌()"
	SpellCostsA[7] = 63
	SpellNamesA[8] = "͂̌(E)"
	SpellCostsA[8] = 63
	SpellNamesA[9] = "ւ̗U"
	SpellCostsA[9] = 654
	SpellNamesA[10] = ""
	SpellCostsA[10] =146
	SpellNamesA[11] = ""
	SpellCostsA[11] = 21
	SpellNamesA[12] = "eFCCgjO"
	SpellCostsA[12] = 156
	SpellNamesA[13] = "eFCCgjO()"
	SpellCostsA[13] = 156
	SpellNamesA[14] = "eFCCgjO(E)"
	SpellCostsA[14] = 156
	SpellNamesA[15] = "̃T[N"
	SpellCostsA[15] = 171
	SpellNamesA[16] = "痢"
	SpellCostsA[16] = 25

	SpellNamesA[17] = "̑"
	SpellCostsA[17] = 126
	SpellNamesA[18] = "̑()"
	SpellCostsA[18] = 126
	SpellNamesA[19] = "fChxz"
	SpellCostsA[19] = 242
	SpellNamesA[20] = "fChxz()"
	SpellCostsA[20] = 242
	SpellNamesA[21] = "hSv[Xg"
	SpellCostsA[21] = 358
	SpellNamesA[22] = "h[h"
	SpellCostsA[22] = 358
	SpellNamesA[23] = "g"
	SpellCostsA[23] = 107
	SpellNamesA[24] = "g(E)"
	SpellCostsA[24] = 107
	SpellNamesA[25] = "̐쏢"
	SpellCostsA[25] = 150
	SpellNamesA[26] = "̐쏢()"
	SpellCostsA[26] = 150
	SpellNamesA[27] = "̐쏢(E)"
	SpellCostsA[27] = 150
	SpellNamesA[28] = "X̐쏢"
	SpellCostsA[28] = 214
	SpellNamesA[29] = "X̐쏢()"
	SpellCostsA[29] = 107
	SpellNamesA[30] = "X̐쏢(E)"
	SpellCostsA[30] = 214
	SpellNamesA[31] = "̐쏢"
	SpellCostsA[31] = 322
	SpellNamesA[32] = "̐쏢()"
	SpellCostsA[32] = 322
	SpellNamesA[33] = "̐쏢(E)"
	SpellCostsA[33] = 322

	SpellNamesA[34] = ""
	SpellCostsA[34] = 39
	SpellNamesA[35] = "̏]k"
	SpellCostsA[35] = 1000
	SpellNamesA[36] = "ҒTm"
	SpellCostsA[36] = 148
	SpellNamesA[37] = "Tm"
	SpellCostsA[37] = 100
	SpellNamesA[38] = "hSXPC"
	SpellCostsA[38] = 837
	SpellNamesA[39] = "xz"
	SpellCostsA[39] = 302
	SpellNamesA[40] = "xz()"
	SpellCostsA[40] = 257
	SpellNamesA[41] = "xz(E)"
	SpellCostsA[41] = 257
	SpellNamesA[42] = "G{j[tbV"
	SpellCostsA[42] = 341
	SpellNamesA[43] = "G{j[tbV()"
	SpellCostsA[43] = 341
	SpellNamesA[44] = "fCh"
	SpellCostsA[44] = 215
	SpellNamesA[45] = "fCh()"
	SpellCostsA[45] = 215
	SpellNamesA[46] = "̌"
	SpellCostsA[46] = 73
	SpellNamesA[47] = "̌()"
	SpellCostsA[47] = 73
	SpellNamesA[48] = "|"
	SpellCostsA[48] = 153
	SpellNamesA[49] = "GNXv[W"
	SpellCostsA[49] = 133
	SpellNamesA[50] = "GNXv[W()"
	SpellCostsA[50] = 133

	SpellNamesA[51] = "GNXv[W(E)"
	SpellCostsA[51] = 133
	SpellNamesA[52] = "t@CA{g"
	SpellCostsA[52] = 41
	SpellNamesA[53] = "t@CA{g()"
	SpellCostsA[53] = 41
	SpellNamesA[54] = "t@CA{g(E)"
	SpellCostsA[54] = 41
	SpellNamesA[55] = ""
	SpellCostsA[55] = 234
	SpellNamesA[56] = "t@CAXg["
	SpellCostsA[56] = 1426
	SpellNamesA[57] = "̃}g"
	SpellCostsA[57] = 289
	SpellNamesA[58] = "̃}g()"
	SpellCostsA[58] = 289
	SpellNamesA[59] = "Ή"
	SpellCostsA[59] = 14
	SpellNamesA[60] = "Ή()"
	SpellCostsA[60] = 14
	SpellNamesA[61] = "Ή(E)"
	SpellCostsA[61] = 14
	SpellNamesA[62] = "̏]k"
	SpellCostsA[62] = 900
	SpellNamesA[63] = ""
	SpellCostsA[63] = 209
	SpellNamesA[64] = "X"
	SpellCostsA[64] = 16
	SpellNamesA[65] = "X()"
	SpellCostsA[65] = 16
	SpellNamesA[66] = "X(E)"
	SpellCostsA[66] = 16
	SpellNamesA[67] = "X̃}g"
	SpellCostsA[67] = 316

	SpellNamesA[68] = "X̃}g()"
	SpellCostsA[68] = 316
	SpellNamesA[69] = "X"
	SpellCostsA[69] = 293
	SpellNamesA[70] = "X̏]k"
	SpellCostsA[70] = 1100
	SpellNamesA[71] = "V"
	SpellCostsA[71] = 67
	SpellNamesA[72] = "厡"
	SpellCostsA[72] = 254
	SpellNamesA[73] = "厡()"
	SpellCostsA[73] = 254
	SpellNamesA[74] = "̃T[N"
	SpellCostsA[74] = 716
	SpellNamesA[75] = "a"
	SpellCostsA[75] = 1052
	SpellNamesA[76] = ""
	SpellCostsA[76] = 12
	SpellNamesA[77] = "̎" ; 77
	SpellCostsA[77] = 25
	SpellNamesA[78] = "()"
	SpellCostsA[78] = 12
	SpellNamesA[79] = "(E)"
	SpellCostsA[79] = 12
	SpellNamesA[80] = "Ҏ"
	SpellCostsA[80] = 80
	SpellNamesA[81] = "ؕ|"
	SpellCostsA[81] = 866
	SpellNamesA[82] = "ACXXpCN"
	SpellCostsA[82] = 48
	SpellNamesA[83] = "ACXXpCN()"
	SpellCostsA[83] = 48
	SpellNamesA[84] = "ACXXpCN(E)"
	SpellCostsA[84] = 48

	SpellNamesA[85] = "ACXXg["
	SpellCostsA[85] = 144 
	SpellNamesA[86] = "ACXXg[()"
	SpellCostsA[86] = 144
	SpellNamesA[87] = "ACXXg[(E)"
	SpellCostsA[87] = 144
	SpellNamesA[88] = "ACXWx"
	SpellCostsA[88] = 320
	SpellNamesA[89] = "ACXWx(E)"
	SpellCostsA[89] = 320
	SpellNamesA[90] = "΋"
	SpellCostsA[90] = 298
	SpellNamesA[91] = "΋()"
	SpellCostsA[91] = 298
	SpellNamesA[92] = "΋(E)"
	SpellCostsA[92] = 298
	SpellNamesA[93] = ""
	SpellCostsA[93] = 334
	SpellNamesA[94] = "ACAtbV"
	SpellCostsA[94] = 266
	SpellNamesA[95] = "ACAtbV()"
	SpellCostsA[95] = 266
	SpellNamesA[96] = "CgjO{g"
	SpellCostsA[96] = 51 
	SpellNamesA[97] = "CgjO{g()"
	SpellCostsA[97] = 51
	SpellNamesA[98] = "CgjO{g(E)"
	SpellCostsA[98] = 51
	SpellNamesA[99] = "̃}g"
	SpellCostsA[99] = 370
	SpellNamesA[100] = "̃}g()"
	SpellCostsA[100] = 172
	SpellNamesA[101] = "CgjOXg["
	SpellCostsA[101] = 138

	SpellNamesA[102] = ""
	SpellCostsA[102] = 84
	SpellNamesA[103] = "Ⴢ̗"
	SpellCostsA[103] = 937
	SpellNamesA[104] = ""
	SpellCostsA[104] = 990
	SpellNamesA[105] = ""
	SpellCostsA[105] = 144
	SpellNamesA[106] = "I[NtbV"
	SpellCostsA[106] = 103
	SpellNamesA[107] = "I[NtbV()"
	SpellCostsA[107] = 103
	SpellNamesA[108] = ""
	SpellCostsA[108] = 290
	SpellNamesA[109] = ""
	SpellCostsA[109] = 450
	SpellNamesA[110] = "HS쐬"
	SpellCostsA[110] = 103
	SpellNamesA[111] = "HS쐬()"
	SpellCostsA[111] = 77
	SpellNamesA[112] = ""
	SpellCostsA[112] = 113
	SpellNamesA[113] = "쐬"
	SpellCostsA[113] = 144
	SpellNamesA[114] = "쐬()"
	SpellCostsA[114] = 114
	SpellNamesA[115] = "쐬(E)"
	SpellCostsA[115] = 114
	SpellNamesA[116] = "Ҍނ̌"
	SpellCostsA[116] = 115
	SpellNamesA[117] = "Ҍނ̑"
	SpellCostsA[117] = 353
	SpellNamesA[118] = "HSxz"
	SpellCostsA[118] = 183

	SpellNamesA[119] = "HSxz()"
	SpellCostsA[119] = 173
	SpellNamesA[120] = "HSxz(E)"
	SpellCostsA[120] = 173
	SpellNamesA[121] = "Ј"
	SpellCostsA[121] = 316
	SpellNamesA[122] = "ShieldLesser"
	SpellCostsA[122] = 0
	SpellNamesA[123] = ""
	SpellCostsA[123] = 323
	SpellNamesA[124] = ""
	SpellCostsA[124] = 107
	SpellNamesA[125] = ""
	SpellCostsA[125] = 19
	SpellNamesA[126] = "()"
	SpellCostsA[126] = 19
	SpellNamesA[127] = "(E)"
	SpellCostsA[127] = 19

	SpellNamesB = new String [26]
	SpellCostsB = new Int[26]

	; 0 is the same as 128
	SpellNamesB[0] = "Xg[tbV"
	SpellCostsB[0] = 194
	SpellNamesB[1] = "Xg[tbV()"
	SpellCostsB[1] = 194
	SpellNamesB[2] = "̏]k"
	SpellCostsB[2] = 1200
	SpellNamesB[3] = "O"
	SpellCostsB[3] = 170
	SpellNamesB[4] = "T_[{g"
	SpellCostsB[4] = 343
	SpellNamesB[5] = "T_[{g(E)"
	SpellCostsB[5] = 343
	SpellNamesB[6] = "҂̗"
	SpellCostsB[6] = 266
	SpellNamesB[7] = "҂̗(E)"
	SpellCostsB[7] = 266
	SpellNamesB[8] = "҂̌"
	SpellCostsB[8] = 84

	SpellNamesB[9] = "҂̌()"
	SpellCostsB[9] = 84
	SpellNamesB[10] = "҂̌(E)"
	SpellCostsB[10] = 84
	SpellNamesB[11] = "҂̑"
	SpellCostsB[11] =168
	SpellNamesB[12] = "҂̑()"
	SpellCostsB[12] =168
	SpellNamesB[13] = "҂̑(E)"
	SpellCostsB[13] =168
	SpellNamesB[14] = "̕"
	SpellCostsB[14] =118
	SpellNamesB[15] = "X̕"
	SpellCostsB[15] =137
	SpellNamesB[16] = "X̕()"
	SpellCostsB[16] =137
	SpellNamesB[17] = "̏"
	SpellCostsB[17] =145
	SpellNamesB[18] = "͂̍"
	SpellCostsB[18] = 86
	SpellNamesB[19] = "͂̍()"
	SpellCostsB[19] = 86
	SpellNamesB[20] = "͂̏"
	SpellCostsB[20] = 34
	SpellNamesB[21] = "͂̏()"
	SpellCostsB[21] = 34
	SpellNamesB[22] = "͂̏"
	SpellCostsB[22] = 58
	SpellNamesB[23] = "͂̏()"
	SpellCostsB[23] = 58
	SpellNamesB[24] = "ċz"
	SpellCostsB[24] = 222
	SpellNamesB[25] = "Ήg"
	SpellCostsB[25] = 57

	initializeSchoolMaps()
EndFunction

Function initializeSchoolMaps()

	; -1 = None
	; 0 = Alteration 
	; 1 = Conjuration 
	; 2 = Destruction 
	; 3 = Illusion 
	; 4 = Restoration

	SpellSchoolsA = new Int[128]
	SpellSchoolsA[0] = 4 ;BaneoftheUndead
	SpellSchoolsA[1] = 1 ;BanishDaedra
	SpellSchoolsA[2] = 1 ;BanishDaedraLeftHand
	SpellSchoolsA[3] = 2 ;Blizzard
	SpellSchoolsA[4] = 1 ;BoundBattleAxe
	SpellSchoolsA[5] = 1 ;BoundBow
	SpellSchoolsA[6] = 1 ;BoundSword
	SpellSchoolsA[7] = 1 ;BoundSwordLeftHand
	SpellSchoolsA[8] = 1 ;BoundSwordRightHand
	SpellSchoolsA[9] = 3 ;CallToArms
	SpellSchoolsA[10] = 3 ;Calm
	SpellSchoolsA[11] = 0 ;Candlelight
	SpellSchoolsA[12] = 2 ;ChainLightning
	SpellSchoolsA[13] = 2 ;ChainLightningLeftHand
	SpellSchoolsA[14] = 2 ;ChainLightningRightHand
	SpellSchoolsA[15] = 4 ;CircleOfProtection
	SpellSchoolsA[16] = 3 ;Clairvoyance

	SpellSchoolsA[17] = 4 ;CloseWounds
	SpellSchoolsA[18] = 4 ;CloseWoundsLeftHand
	SpellSchoolsA[19] = 1 ;CommandDaedra
	SpellSchoolsA[20] = 1 ;CommandDaedraLeftHand
	SpellSchoolsA[21] = 1 ;ConjureDragonPriest
	SpellSchoolsA[22] = 1 ;ConjureDremoraLord
	SpellSchoolsA[23] = 1 ;ConjureFamiliar
	SpellSchoolsA[24] = 1 ;ConjureFamiliarRightHand
	SpellSchoolsA[25] = 1 ;ConjureFlameAtronach
	SpellSchoolsA[26] = 1 ;ConjureFlameAtronachLeftHand
	SpellSchoolsA[27] = 1 ;ConjureFlameAtronachRightHand
	SpellSchoolsA[28] = 1 ;ConjureFrostAtronach
	SpellSchoolsA[29] = 1 ;ConjureFrostAtronachLeftHand
	SpellSchoolsA[30] = 1 ;ConjureFrostAtronachRightHand
	SpellSchoolsA[31] = 1 ;ConjureStormAtronach
	SpellSchoolsA[32] = 1 ;ConjureStormAtronachLeftHand
	SpellSchoolsA[33] = 1 ;ConjureStormAtronachRightHand

	SpellSchoolsA[34] = 3 ;Courage
	SpellSchoolsA[35] = 1 ;DeadThrall
	SpellSchoolsA[36] = 0 ;DetectDead
	SpellSchoolsA[37] = 0 ;DetectLife
	SpellSchoolsA[38] = 0 ;Dragonhide
	SpellSchoolsA[39] = 1 ;DreadZombie
	SpellSchoolsA[40] = 1 ;DreadZombieLeftHand
	SpellSchoolsA[41] = 1 ;DreadZombieRightHand
	SpellSchoolsA[42] = 0 ;Ebonyflesh
	SpellSchoolsA[43] = 0 ;EbonyfleshLeftHand
	SpellSchoolsA[44] = 1 ;ExpelDaedra
	SpellSchoolsA[45] = 1 ;ExpelDaedraLeftHand
	SpellSchoolsA[46] = 4 ;FastHealing
	SpellSchoolsA[47] = 4 ;FastHealingLeftHand
	SpellSchoolsA[48] = 3 ;Fear
	SpellSchoolsA[49] = 2 ;Fireball
	SpellSchoolsA[50] = 2 ;FireballLeftHand

	SpellSchoolsA[51] = 2 ;FireballRightHand
	SpellSchoolsA[52] = 2 ;Firebolt
	SpellSchoolsA[53] = 2 ;FireboltLeftHand
	SpellSchoolsA[54] = 2 ;FireboltRightHand
	SpellSchoolsA[55] = 2 ;FireRune
	SpellSchoolsA[56] = 2 ;FireStorm
	SpellSchoolsA[57] = 2 ;FlameCloak
	SpellSchoolsA[58] = 2 ;FlameCloakLeftHand
	SpellSchoolsA[59] = 2 ;Flames
	SpellSchoolsA[60] = 2 ;FlamesLeftHand
	SpellSchoolsA[61] = 2 ;FlamesRightHand
	SpellSchoolsA[62] = 1 ;FlameThrall
	SpellSchoolsA[63] = 3 ;Frenzy
	SpellSchoolsA[64] = 2 ;Frostbite
	SpellSchoolsA[65] = 2 ;FrostbiteLeftHand
	SpellSchoolsA[66] = 2 ;FrostbiteRightHand
	SpellSchoolsA[67] = 2 ;FrostCloak

	SpellSchoolsA[68] = 2 ;FrostCloakLeftHand
	SpellSchoolsA[69] = 2 ;FrostRune
	SpellSchoolsA[70] = 1 ;FrostThrall
	SpellSchoolsA[71] = 3 ;Fury
	SpellSchoolsA[72] = 4 ;GrandHealing
	SpellSchoolsA[73] = 4 ;GrandHealingLeftHand
	SpellSchoolsA[74] = 4 ;GuardianCircle
	SpellSchoolsA[75] = 3 ;Harmony
	SpellSchoolsA[76] = 4 ;Healing
	SpellSchoolsA[77] = 4 ;HealingHands
	SpellSchoolsA[78] = 4 ;HealingLeftHand
	SpellSchoolsA[79] = 4 ;HealingRightHand
	SpellSchoolsA[80] = 4 ;HealOther
	SpellSchoolsA[81] = 3 ;Hysteria
	SpellSchoolsA[82] = 2 ;IceSpike
	SpellSchoolsA[83] = 2 ;IceSpikeLeftHand
	SpellSchoolsA[84] = 2 ;IceSpikeRightHand

	SpellSchoolsA[85] = 2 ;IceStorm
	SpellSchoolsA[86] = 2 ;IceStormLeftHand
	SpellSchoolsA[87] = 2 ;IceStormRightHand
	SpellSchoolsA[88] = 2 ;IcySpear
	SpellSchoolsA[89] = 2 ;IcySpearRightHand
	SpellSchoolsA[90] = 2 ;Incinerate
	SpellSchoolsA[91] = 2 ;IncinerateLeftHand
	SpellSchoolsA[92] = 2 ;IncinerateRightHand
	SpellSchoolsA[93] = 3 ;Invisibility
	SpellSchoolsA[94] = 0 ;Ironflesh
	SpellSchoolsA[95] = 0 ;IronfleshLeftHand
	SpellSchoolsA[96] = 2 ;LightningBolt
	SpellSchoolsA[97] = 2 ;LightningBoltLeftHand
	SpellSchoolsA[98] = 2 ;LightningBoltRightHand
	SpellSchoolsA[99] = 2 ;LightningCloak
	SpellSchoolsA[100] = 2 ;LightningCloakLeftHand
	SpellSchoolsA[101] = 2 ;LightningStorm
	
	SpellSchoolsA[102] = 0 ;Magelight
	SpellSchoolsA[103] = 0 ;MassParalysis
	SpellSchoolsA[104] = 3 ;Mayhem
	SpellSchoolsA[105] = 3 ;Muffle
	SpellSchoolsA[106] = 0 ;Oakflesh
	SpellSchoolsA[107] = 0 ;OakfleshLeftHand
	SpellSchoolsA[108] = 3 ;Pacify
	SpellSchoolsA[109] = 0 ;Paralyze
	SpellSchoolsA[110] = 1 ;RaiseZombie
	SpellSchoolsA[111] = 1 ;RaiseZombieLeftHand
	SpellSchoolsA[112] = 3 ;Rally
	SpellSchoolsA[113] = 1 ;ReanimateCorpse
	SpellSchoolsA[114] = 1 ;ReanimateCorpseLeftHand
	SpellSchoolsA[115] = 1 ;ReanimateCorpseRightHand
	SpellSchoolsA[116] = 4 ;RepelLesserUndead
	SpellSchoolsA[117] = 4 ;RepelUndead
	SpellSchoolsA[118] = 1 ;Revenant
	
	SpellSchoolsA[119] = 1 ;RevenantLeftHand
	SpellSchoolsA[120] = 1 ;RevenantRighHand
	SpellSchoolsA[121] = 3 ;Rout
	SpellSchoolsA[122] = 4 ;ShieldLesser
	SpellSchoolsA[123] = 2 ;ShockRune
	SpellSchoolsA[124] = 1 ;SoulTrap
	SpellSchoolsA[125] = 2 ;Sparks
	SpellSchoolsA[126] = 2 ;SparksLeftHand
	SpellSchoolsA[127] = 2 ;SparksRightHand
	
	SpellSchoolsB = new Int[26]

	; 0 is the same as 128
	SpellSchoolsB[0] = 0 ;Stoneflesh
	SpellSchoolsB[1] = 0 ;StonefleshLeftHand
	SpellSchoolsB[2] = 1 ;StormThrall
	SpellSchoolsB[3] = 0 ;Telekinesis
	SpellSchoolsB[4] = 2 ;Thunderbolt
	SpellSchoolsB[5] = 2 ;ThunderboltRightHand
	SpellSchoolsB[6] = 4 ;TurnGreaterUndead
	SpellSchoolsB[7] = 4 ;TurnGreaterUndeadRightHand
	SpellSchoolsB[8] = 4 ;TurnLesserUndead

	SpellSchoolsB[9] = 4 ;TurnLesserUndeadLeftHand
	SpellSchoolsB[10] = 4 ;TurnLesserUndeadRightHand
	SpellSchoolsB[11] = 4 ;TurnUndead
	SpellSchoolsB[12] = 4 ;TurnUndeadLeftHand
	SpellSchoolsB[13] = 4 ;TurnUndeadRightHand
	SpellSchoolsB[14] = 2 ;WallOfFlames
	SpellSchoolsB[15] = 2 ;WallOfFrost
	SpellSchoolsB[16] = 2 ;WallOfFrostLeftHand
	SpellSchoolsB[17] = 2 ;WallOfStorms
	SpellSchoolsB[18] = 4 ;WardGreater
	SpellSchoolsB[19] = 4 ;WardGreaterLeftHand
	SpellSchoolsB[20] = 4 ;WardLesser
	SpellSchoolsB[21] = 4 ;WardLesserLeftHand
	SpellSchoolsB[22] = 4 ;WardSteadfast
	SpellSchoolsB[23] = 4 ;WardSteadfastLeftHand
	SpellSchoolsB[24] = 0 ;Waterbreathing
	SpellSchoolsB[25] = 1 ;Flaming Familiar

EndFunction

Function v16Update()
	SpellNamesB[25] = "Ήg"
	SpellCostsB[25] = 57
	if (153 == TweakSpellList.GetSize())
		; should be 154
		Debug.Notification("Updating Spell List")
		TweakSpellList.AddForm(dunHighGateSummonFlamingThrall)
	endif
EndFunction

Function v161Update()
	initializeSchoolMaps()
EndFunction

Function SetDisableMagic(ObjectReference Follower, Bool value)
	ReferenceAlias theAlias = pTweakFollowerScript.FindAlias(Follower)
	if (!theAlias)
		Warning()
		return
	endif
	if (pTweakFollowerScript.showMessages && !DisableMagicHintOnce)
		DisableMagicHintOnce = true
		String msg = "@gpsɂꍇAtH[̃}WJ0ɂȂ܂B "
 		msg += "͎悤Ƃ邱Ƃh߂łB "
 		msg += "̐퓬X^CIꍇAIɂ̐ݒ肪L܂B\n\n"
 		msg += "m^Cvɖ@g킹邱Ƃł܂AݒƂ͈قȂ"
 		msg += "킢\܂B ڍׂ͐ݒ̍ĂB"
		Debug.MessageBox(msg)  
	endif
	(theAlias as TweakMagic).SetDisableMagic(value)
endFunction


Function ToggleFirstSpellUse(ObjectReference follower, Bool value)
	ReferenceAlias theAlias = pTweakFollowerScript.FindAlias(follower)
	if (!theAlias)
		Warning()
		return
	endif
	(theAlias as TweakMagic).ToggleFirstSpellUse(value)
endFunction

Function ToggleSecondSpellUse(ObjectReference follower, Bool value)
	ReferenceAlias theAlias = pTweakFollowerScript.FindAlias(follower)
	if (!theAlias)
		Warning()
		return
	endif
	(theAlias as TweakMagic).ToggleSecondSpellUse(value)
endFunction

Function ToggleThirdSpellUse(ObjectReference follower, Bool value)
	ReferenceAlias theAlias = pTweakFollowerScript.FindAlias(follower)
	if (!theAlias)
		Warning()
		return
	endif
	(theAlias as TweakMagic).ToggleThirdSpellUse(value)
endFunction

Function ToggleFourthSpellUse(ObjectReference follower, Bool value)
	ReferenceAlias theAlias = pTweakFollowerScript.FindAlias(follower)
	if (!theAlias)
		Warning()
		return
	endif
	(theAlias as TweakMagic).ToggleFourthSpellUse(value)
endFunction

Function ViewCombatSpells(ObjectReference follower)

	ReferenceAlias theAlias = pTweakFollowerScript.FindAlias(follower)
	if (!theAlias)
		Warning()
		return
	endif
	if (pTweakFollowerScript.showMessages && !ViewTeachCombatHintOnce)
		ViewTeachCombatHintOnce= true
		String msg = "tH[oĂāA\ȃ}WJƂA"
		msg += "@ĝ悤ɐU镑ēGƂ̋ۂ܂B"
		msg += "ݒtH[̎XgɉĂ܂B "
		msg += "ݒɂA퓬JnƓɈ܂͓"
		msg += "Ǎˌ悤ɐݒ肷邱Ƃł܂B"
		msg += "tH[ɁA̎}WJ "
		msg += "\邱ƂKvłB"
		Debug.MessageBox(msg)  
	endif
	(theAlias as TweakMagic).ViewCombatSpells()

endFunction

Function SetSpell(ObjectReference follower, int slot = 1)
	
	ReferenceAlias theAlias = pTweakFollowerScript.FindAlias(follower)
	if (!theAlias)
		Warning()
		return
	endif

	Spell leftHand  = Game.GetPlayer().GetEquippedSpell(0)
	Spell rightHand = Game.GetPlayer().GetEquippedSpell(1)

	if (leftHand && rightHand)
		if (leftHand != rightHand)
			if (pTweakFollowerScript.showMessages)
				Debug.MessageBox("x:ɎĂ܂B͖܂")
				Utility.wait(0.1)
			endif
		endif
	endif
	Spell theSpell
	Actor actorRef = follower As Actor

	if (rightHand)
		theSpell = rightHand
	else
		theSpell = leftHand
	endif

	int index = -1
	int spellSchool = -1
	int spellCost = 1
	String spellName = "Unknown"
	bool dgspell = False
	bool dbspell = False
	
	if (pTweakDawnGuardScript.installed)
		index = pTweakDawnGuardScript.GetSpellIndex(theSpell)
		if (-1 != index)
			spellCost = pTweakDawnGuardScript.GetSpellCost(index)
			spellName = pTweakDawnGuardScript.GetSpellName(index)
			spellSchool = pTweakDawnGuardScript.GetSpellSchool(index)
			dgspell = true
		endif
	endif
	if (-1 == index && pTweakDragonBornScript.installed)
		index = pTweakDragonBornScript.GetSpellIndex(theSpell)
		if (-1 != index)
			spellCost = pTweakDragonBornScript.GetSpellCost(index)
			spellName = pTweakDragonBornScript.GetSpellName(index)
			spellSchool = pTweakDragonBornScript.GetSpellSchool(index)
			dbspell = true
		endif
	endif
	if (-1 == index)
		index = GetSpellIndex(theSpell)
		if (-1 != index)
			spellCost = GetSpellCost(index)
			spellName = GetSpellName(index)
			spellSchool = GetSpellSchool(index)
		endif
	endif
	if (-1 == index)
		if (theSpell.GetFormID() < 0x00FFFFFF)
			Debug.MessageBox("x: T|[gĂȂĂ܂Bݒ͒~܂B")
			return
		endif
		int continue = TweakLSpellConfirm.Show()
		if (0 != continue)
			Return
		endif
		TweakCustomSpells.AddForm(theSpell)
		index = GetSpellIndex(theSpell)
		spellCost = GetSpellCost(index)
		spellName = GetSpellName(index)
	endif

	isEnemyOption = false

	int spellType = 0
	int tType = 0

	if ((TweakCustomSpells.GetSize() > 0 && TweakCustomSpells.HasForm(theSpell)) || (dgspell) || (dbspell))
		isEnemyOption = true
		tType =  TweakSpellType.show()
	else
		if (TweakPCTargetSpells.HasForm(theSpell))
			tType = TweakSpellType.show()
			spellType = 1
		elseif (TweakSummonSpells.HasForm(theSpell))
			tType = 2
			spellType = 2
		elseif (TweakSelfTargetSpells.HasForm(theSpell))
			tType = 2
			spellType = 3
		endif
	endif

	if (0 == tType)
		int detail = TWeakSpellWhenAttack.show()
		if (1 == detail) ; 2nd target
			spellType = 10
		elseif (2 == detail) ; 3rd target
			spellType = 11
		endif
	elseif (1 == tType) ; PC Buff
		int detail = TweakSpellCriteria.show()
		if (1 == detail) ; Health < 75
			spellType = 7
		elseif (2 == detail) ; Health < 50
			spellType = 8
		elseif (3 == detail) ; Health < 25
			spellType = 9
		endif
	elseif (2 == tType); NPC Buff
		int detail = TweakSpellWhenBuff.show()
		if (1 == detail) ; Health < 75
			spellType = 4
		elseif (2 == detail) ; Health < 50
			spellType = 5
		elseif (3 == detail) ; Health < 25
			spellType = 6
		endif
	endif

	if (4 == slot)
		(theAlias as TweakMagic).SetFourthSpell(theSpell, spellType, spellName, spellCost, spellSchool)
	elseif (3 == slot)
		(theAlias as TweakMagic).SetThirdSpell(theSpell, spellType, spellName, spellCost, spellSchool)
	elseif (2 == slot)
		(theAlias as TweakMagic).SetSecondSpell(theSpell, spellType, spellName, spellCost, spellSchool)
	else 
		(theAlias as TweakMagic).SetFirstSpell(theSpell, spellType, spellName, spellCost, spellSchool)
	endif

endFunction

Function Hints()

	if (pTweakFollowerScript.showMessages && !AddSetHintOnce)
		AddSetHintOnce = true
		String msg = "ݒ肵苳邽߂ɂ́AtH[ɘbOɎ\ĂBꍇ "
		msg += "2̖@𑕔ĂꍇAƂ邱Ƃł܂B"
		Debug.MessageBox(msg)
		Utility.wait(0.1)
	endif
	if (pTweakFollowerScript.showMessages && !ViewTeachCombatHintOnce)
		ViewTeachCombatHintOnce= true
		String msg = "tH[oĂāA\ȃ}WJƂA"
		msg += "@ĝ悤ɐU镑ēGƂ̋ۂ܂B"
		msg += "ݒɂA퓬JnƓɈ܂͓ "
		msg += "Ǎˌ悤Ȗ@mX^Cݒł܂B"
		msg += "ꂽ퓬`hɂAݒ퓬Jnɉrł܂B "
		msg += "ݒtH[̎Xgɂ܂B\n\n"
		msg += "ݒ́AdvȎ퓬JnɕKr悤ɂł邽߁A"
		msg += "@gX^CłLłB "
		Debug.MessageBox(msg)  
	endif
endFunction

int Function GetCustomSpellType(Spell theSpell)
	int stype = TweakSpellType.show()
	if (0 == stype) ; attack
		int detail = TWeakSpellWhenAttack.show()
		if (1 == detail) ; 2nd target
			stype = 10
		elseif (2 == detail) ; 3rd target
			stype = 11
		endif
	elseif (1 == stype) ; PC Buff
		int detail = TweakSpellWhenBuff.show()
		if (1 == detail) ; Health < 75
			stype = 7
		elseif (2 == detail) ; Health < 50
			stype = 8
		elseif (3 == detail) ; Health < 25
			stype = 9
		endif
	elseif (3 == stype) ; NPC Buff
		int detail = TweakSpellWhenBuff.show()
		if (1 == detail) ; Health < 75
			stype = 4
		elseif (2 == detail) ; Health < 50
			stype = 5
		elseif (3 == detail) ; Health < 25
			stype = 6
		endif
	elseif (4 == sType)
		Form spellForm = theSpell As Form
		sType = 0
		if (TweakPCTargetSpells.HasForm(spellForm))
			sType = 1
		elseif (TweakSummonSpells.HasForm(spellForm))
			sType = 2
		elseif (TweakSelfTargetSpells.HasForm(spellForm))
			sType = 3
		endif
	endif
	return sType
endFunction

Function RemoveSpell(ObjectReference follower)

	Spell leftHand = Game.GetPlayer().GetEquippedSpell(0)
	Spell rightHand = Game.GetPlayer().GetEquippedSpell(1)
	Actor actorRef = follower as Actor

	if (leftHand)
		if (actorRef.HasSpell(leftHand))
			int index = -1
			String spellName = "Unknown"
			if (pTweakDawnGuardScript.installed)
				index = pTweakDawnGuardScript.GetSpellIndex(leftHand)
				if (-1 != index)
					spellName = pTweakDawnGuardScript.GetSpellName(index)
				endif
			endif
			if (-1 == index && pTweakDragonBornScript.installed)
				index = pTweakDragonBornScript.GetSpellIndex(leftHand)
				if (-1 != index)
					spellName = pTweakDragonBornScript.GetSpellName(index)
				endif
			endif
			if (-1 == index)
				index = GetSpellIndex(leftHand)
				if (-1 != index)
					spellName = GetSpellName(index)
				endif
			endif
			if (-1 == index)
				RemoveForm(TweakCustomSpells, leftHand)
			endif
			if (pTweakFollowerScript.showMessages)
				Debug.MessageBox("tH[ [" + spellName + "] Yꂳ܂B")
			endif
			actorRef.RemoveSpell(leftHand)
		Else
			if (pTweakFollowerScript.showMessages)
				Debug.MessageBox("͖܂BtH[͂̎oĂ܂B")
			endif
		endif
	endif
	if (rightHand && rightHand != leftHand)
		if (actorRef.HasSpell(rightHand))
			int index = -1
			String spellName = "Unknown"
	
			if (pTweakDawnGuardScript.installed)
				index = pTweakDawnGuardScript.GetSpellIndex(rightHand)
				if (-1 != index)
					spellName = pTweakDawnGuardScript.GetSpellName(index)
				endif
			endif
			if (-1 == index && pTweakDragonBornScript.installed)
				index = pTweakDragonBornScript.GetSpellIndex(rightHand)
				if (-1 != index)
					spellName = pTweakDragonBornScript.GetSpellName(index)
				endif
			endif
			if (-1 == index)
				index = GetSpellIndex(rightHand)
				if (-1 != index)
					spellName = GetSpellName(index)				
				endif
			endif
			if (-1 == index)
				RemoveForm(TweakCustomSpells, leftHand)
			endif
			if (pTweakFollowerScript.showMessages)
				Debug.MessageBox("tH[ [" + spellName + "] Yꂳ܂B")
			endif
			actorRef.RemoveSpell(rightHand)
		else
			if (pTweakFollowerScript.showMessages)
				Debug.MessageBox("E͖܂BtH[͂̎oĂ܂B")
			endif
		endif
	endif
endFunction

Function AddSpell(ObjectReference follower)

	if (pTweakFollowerScript.showMessages && !ViewTeachHintOnce)
		ViewTeachHintOnce = true
		String msg = "tH[oĂāA\ȃ}WJƂA"
		msg += "@ĝ悤ɐU镑ēGƂ̋ۂ܂B"
		msg += "UIȖ@mɂꍇ́AɐݒgƂlĂ݂ĂB"
		Debug.MessageBox(msg)
		Utility.wait(0.1)
	endif
	if (pTweakFollowerScript.showMessages && !AddSetHintOnce)
		AddSetHintOnce = true
		String msg = "ݒ肵苳邽߂ɂ́AtH[ɘbOɎ\ĂBꍇ "
		msg += "@𗼎ɑĂ΁AƂ邱Ƃł܂B"
		Debug.MessageBox(msg)  
		Utility.wait(0.1)
	endif

	Spell leftHand = Game.GetPlayer().GetEquippedSpell(0)
	Spell rightHand = Game.GetPlayer().GetEquippedSpell(1)
	Actor actorRef = follower as Actor

	if (leftHand)
		if (actorRef.HasSpell(leftHand))
			if (pTweakFollowerScript.showMessages)
				Debug.MessageBox("͖܂BtH[͂łɂ̎oĂ܂B")
			endif
		else
			int index = -1
			String spellName = "Unknown"
	
			if (pTweakDawnGuardScript.installed)
				index = pTweakDawnGuardScript.GetSpellIndex(leftHand)
				if (-1 != index)
					spellName = pTweakDawnGuardScript.GetSpellName(index)
				endif
			endif
			if (-1 == index && pTweakDragonBornScript.installed)
				index = pTweakDragonBornScript.GetSpellIndex(leftHand)
				if (-1 != index)
					spellName = pTweakDragonBornScript.GetSpellName(index)
				endif
			endif
			if (-1 == index)
				index = GetSpellIndex(leftHand)
				if (-1 != index)
					spellName = GetSpellName(index)
				endif
			endif
			if (-1 == index)
				if (leftHand.GetFormID() < 0x00FFFFFF)
					Debug.MessageBox("͖܂BT|[gĂȂłB")
					return
				endif
				int continue = TweakLSpellConfirm.Show()
				if (0 != continue)
					return
				endif
				TweakCustomSpells.AddForm(leftHand)
				index = GetSpellIndex(leftHand)
				spellName = GetSpellName(index)
			endif
			if (pTweakFollowerScript.showMessages)
				Debug.MessageBox("tH[ [" + spellName + "] o܂B")
			endif
			actorRef.addSpell(leftHand)
		endif
	endif
	if (rightHand)
		if (rightHand != leftHand)
			if (actorRef.HasSpell(rightHand))
				if (pTweakFollowerScript.showMessages)
					Debug.MessageBox("E͖܂BtH[͂łɂ̎oĂ܂B")
				endif
			else
				int index = -1
				String spellName = "Unknown"
	
				if (pTweakDawnGuardScript.installed)
					index = pTweakDawnGuardScript.GetSpellIndex(rightHand)
					if (-1 != index)
						spellName = pTweakDawnGuardScript.GetSpellName(index)
					endif
				endif
				if (-1 == index && pTweakDragonBornScript.installed)
					index = pTweakDragonBornScript.GetSpellIndex(rightHand)
					if (-1 != index)
						spellName = pTweakDragonBornScript.GetSpellName(index)
					endif
				endif
				if (-1 == index)
					index = GetSpellIndex(rightHand)
					if (-1 != index)
						spellName = GetSpellName(index)				
					endif
				endif
				if (-1 == index)
					if (rightHand.GetFormID() < 0x00FFFFFF)
						Debug.MessageBox("E͖܂BT|[gĂȂłB")
						return
					endif
					int continue = TweakRSpellConfirm.Show()
					if (0 != continue)
						return
					endif
					TweakCustomSpells.AddForm(rightHand)
					index = GetSpellIndex(rightHand)
					spellName = GetSpellName(index)
				endif
				if (pTweakFollowerScript.showMessages)
					Debug.MessageBox("tH[ [" + spellName + "] o܂B")
				endif
				actorRef.addSpell(rightHand)
			endif
		endif
	endif

endFunction

Function ResetTweakSpells(ObjectReference follower)

	ReferenceAlias theAlias = pTweakFollowerScript.FindAlias(follower)
	if (!theAlias)
		Warning()
		return
	endif

	(theAlias as TweakMagic).ClearCombatSpells()

endFunction

Function ClearNewSpells(ObjectReference follower)

	if (pTweakFollowerScript.showMessages && !ClearHintOnce)
		ClearHintOnce=true
		String msg = "̃R}hɂAtH[̖@܂B "
		msg += "Ȃ̃tH[ƂȂOɂłɖ@oĂꍇA " 
		msg += "͎̎菜܂B " 
		msg += "MODɂύXꂽ̂ɖ߂܂B"
		Debug.MessageBox(msg)
	endif

	int total = TweakSpellList.GetSize()
	int i = 0
	Spell spellRef
	Actor actorRef = follower as Actor

	while(i < total)
		spellRef = (TweakSpellList.getat(i) As Spell)
		if (actorRef.HasSpell(spellRef))
			Utility.wait(0.1)
			actorRef.RemoveSpell(spellRef)
		endif
		i = i + 1
	endWhile

	total = TweakCustomSpells.GetSize()
	i = 0

	while(i < total)
		spellRef = (TweakCustomSpells.getat(i) As Spell)
		if (actorRef.HasSpell(spellRef))
			Utility.wait(0.1)
			actorRef.RemoveSpell(spellRef)
		endif
		i = i + 1
	endWhile
	
	if (pTweakDawnGuardScript.installed)
		total = pTweakDawnGuardScript.SpellMap.length
		i = 0
		while(i < total)
			spellRef = pTweakDawnGuardScript.SpellMap[i]
			if (actorRef.HasSpell(spellRef))
				Utility.wait(0.1)
				actorRef.RemoveSpell(spellRef)
			endif
			i = i + 1
		endWhile
	endif
	
	if (pTweakDragonBornScript.installed)
		total = pTweakDragonBornScript.SpellMap.length
		i = 0
		while(i < total)
			spellRef = pTweakDragonBornScript.SpellMap[i]
			if (actorRef.HasSpell(spellRef))
				Utility.wait(0.1)
				actorRef.RemoveSpell(spellRef)
			endif
			i = i + 1
		endWhile
	endif

endFunction

Function InfoSpells(ObjectReference follower, Bool skipHint = False)
	
	if (pTweakFollowerScript.showMessages && !ViewTeachHintOnce && !skipHint)
		ViewTeachHintOnce = true
		String msg = "tH[oĂāA\ȃ}WJƂA"
		msg += "@ĝ悤ɐU镑ēGƂ̋ۂ܂B "
		msg += "UIȖ@mɂꍇ́AݒgƂlĂ݂ĂB"
		Debug.MessageBox(msg)
		Utility.wait(0.1)
	endif

	int range1 = TweakSpellList.GetSize()
	int range2 = TweakCustomSpells.GetSize()
	int range3 = 0
	if (pTweakDawnGuardScript.installed)
		range3 = pTweakDawnGuardScript.SpellMap.length
	endif
	int range4 = 0
	if (pTweakDragonBornScript.installed)
		range4 = pTweakDragonBornScript.SpellMap.length
	endif

	int milestone1 = range1
	int milestone2 = range1 + range2
	int milestone3 = range1 + range2 + range3
	int milestone4 = range1 + range2 + range3 + range4
	int total = milestone4 + 2

	int i = 0
	int offset = 0
	int count = 1
	int msgBoxes = 0
	Actor actorRef = follower as Actor

    string status = "}WJ: "
	status += (actorRef.GetAv("magicka") as Int)
	status += "   :\n\n"

	; Use Threaded method to do bulk search
	Int[] results = pTweakTMScript.GetSpells(follower)
	if (results)
		int numresults = pTweakThreadCount.GetValueInt()
	
		while(i < numresults)
			if (0 == count)
					status = " (cont):\n\n"
				count += 1
			endif
			
			int actualcost 
			int school = GetSpellSchool(results[i])
			if (school != -1)

				; Schools
				; -1 = None
				; 0 = Alteration 
				; 1 = Conjuration 
				; 2 = Destruction 
				; 3 = Illusion 
				; 4 = Restoration

				float skill  = 0.0
				if 0 == school
					skill = actorRef.GetAV("Alteration")
				elseif 1 == school 
					skill = actorRef.GetAV("Conjuration")
				elseif 2 == school 
					skill = actorRef.GetAV("Destruction")
				elseif 3 == school 
					skill = actorRef.GetAV("Illusion")
				elseif 4 == school
					skill = actorRef.GetAV("Restoration")
				endif
				
				int base   = GetSpellCost(results[i])			
				actualcost = (base - (base * (0.71 * skill/100))) As Int		
			else
				actualcost = GetSpellCost(results[i])
			endif
			
			status += "[" + GetSpellName(results[i]) + " : " + actualcost + "]\n"
			count += 1
			if (11 == count)
				Debug.MessageBox(status)
				Utility.wait(0.1)
				count = 0
				msgBoxes += 1
			endif
			i += 1
		endWhile
	endif
	
	i = milestone1
	Spell spellRef
	while(i != total)
		if (0 == count)
    			status = " (cont):\n\n"
			count += 1
		endif
		if (i < milestone2)
			spellRef = (GetSpellByIndex(i) as Spell)
			if (spellRef && actorRef.HasSpell(spellRef))
				status += "[" + GetSpellName(i) + " : " + GetSpellCost(i) + "]\n"
				count += 1
			endif
		elseif (i < milestone3)
			int m = i - milestone2 
			spellRef = pTweakDawnGuardScript.SpellMap[m]
			if (spellRef && actorRef.HasSpell(spellRef))
			
				int actualcost
				int school = pTweakDawnGuardScript.GetSpellSchool(m)
				if (school != -1)
					float skill  = 0.0
					if 0 == school
						skill = actorRef.GetAV("Alteration")
					elseif 1 == school 
						skill = actorRef.GetAV("Conjuration")
					elseif 2 == school 
						skill = actorRef.GetAV("Destruction")
					elseif 3 == school 
						skill = actorRef.GetAV("Illusion")
					elseif 4 == school
						skill = actorRef.GetAV("Restoration")
					endif
					int base   = pTweakDawnGuardScript.GetSpellCost(m)			
					actualcost = (base - (base * (0.71 * skill/100))) As Int		
				else
					actualcost = pTweakDawnGuardScript.GetSpellCost(m)
				endif
			
				status += "[" + pTweakDawnGuardScript.GetSpellName(m) + " : " + actualcost + "]\n"
				count += 1
			endif
		elseif (i < milestone4)
			int m = i - milestone3 
			spellRef = pTweakDragonBornScript.SpellMap[m]
			if (spellRef && actorRef.HasSpell(spellRef))

				int actualcost
				int school = pTweakDragonBornScript.GetSpellSchool(m)
				if (school != -1)
					float skill  = 0.0
					if 0 == school
						skill = actorRef.GetAV("Alteration")
					elseif 1 == school 
						skill = actorRef.GetAV("Conjuration")
					elseif 2 == school 
						skill = actorRef.GetAV("Destruction")
					elseif 3 == school 
						skill = actorRef.GetAV("Illusion")
					elseif 4 == school
						skill = actorRef.GetAV("Restoration")
					endif
					int base   = pTweakDragonBornScript.GetSpellCost(m)			
					actualcost = (base - (base * (0.71 * skill/100))) As Int		
				else
					actualcost = pTweakDragonBornScript.GetSpellCost(m)
				endif
				
				status += "[" + pTweakDragonBornScript.GetSpellName(m) + " : " + actualcost + "]\n"
				count += 1
			endif
		else
			int extra = i - milestone4
			if (0 == extra)
				if (actorRef.HasSpell(VampireDrain01) || actorRef.HasSpell(VampireDrain02) || actorRef.HasSpell(VampireDrain03) || actorRef.HasSpell(VampireDrain04))
					status += "[zS̋z]\n"
					count += 1
				endif
			elseif (1 == extra)
				if (actorRef.HasSpell(VampireCharm))
					status += "[zS̗Uf]\n"
					count += 1
				endif
			endif
		endif
		if (11 == count)
			Debug.MessageBox(status)
			Utility.wait(0.1)
			count = 0
			msgBoxes += 1
		endif
		i += 1 
	endWhile
	if (1 == count)
		if (0 == msgBoxes)
			status += "[Ȃ]\n"
		else
			return
		endif
	endif

	Debug.MessageBox(status)
	Utility.wait(0.1)

endFunction

Form Function GetSpellByIndex(int index)

	if (index < 0)
		return None
	elseif (index < 154)
		return TweakSpellList.getat(index)
	else
		int i = index -  154
		if (i < TweakCustomSpells.GetSize())
			return TweakCustomSpells.getat(i)
		endif
	endif
	return None

endFunction

int Function GetSpellIndex(Spell theSpell)

	int total = TweakSpellList.GetSize()
	int i = 0

	Form formRef = theSpell As Form
	Form spellRef

	while(i != total)
		spellRef = TweakSpellList.getat(i)
		if (spellRef == formRef)
			return i
		endif
		i = i + 1
	endWhile

	total = TweakCustomSpells.GetSize()
	if (total > 0)
		i = 0
		while(i != total)
			spellRef = TweakCustomSpells.getat(i)
			if (spellRef == formRef)
				return (i + 154)
			endif
			i = i + 1
		endWhile
	endif
	return (-1)

endFunction 

String Function GetSpellName(int index)

	if (-1 == index) 
		return "Unknown" 
	endif 

	if (index < 128)
		return SpellNamesA[index]
	elseif (index < 154)
		return SpellNamesB[(index - 128)]
	else
		return "Custom_" + (index - 153)
	endif

endFunction

Int Function GetSpellCost(int index)

	if (-1 == index) 
		return 0
	endif

	if (index < 128)
		return SpellCostsA[index]
	elseif (index < 154)
		return SpellCostsA[(index - 128)]
	else
		return 500
	endif

endFunction

Int Function GetSpellSchool(int index)

	if (-1 == index) 
		return -1
	endif 

	if (index < 128)
		return SpellSchoolsA[index]
	elseif (index < 154)
		return SpellSchoolsB[(index - 128)]
	endif
	return -1

endFunction

Function RemoveForm(FormList source, Form f)
	int size=source.GetSize()
	if (size > 0)
		TweakEmptyList.Revert()
		int i=0
		bool notFound=true
		Form item
		while (i != size && notFound)
			item = source.GetAt(i)
			if (item != f)
				TweakEmptyList.AddForm(item)
			else
				notFound=false
			endif
			i += 1
		endWhile
		if (!notFound)
			while (i != size)
				TweakEmptyList.AddForm(source.GetAt(i))
				i += 1
			endWhile
			source.Revert()
			size = TweakEmptyList.GetSize()
			if (size > 0)
				i=0
				while (i < size)
					source.AddForm(TweakEmptyList.GetAt(i))
					i += 1
				endWhile
			endif
		endIf
	endIf
endFunction

Function Warning()
		Debug.MessageBox("FłȂtH[łBAmazing Follower Tweaks CXg[ĂǏ]悤񂾂Ƃ܂H")
endFunction
