﻿Scriptname TweakMagic extends ReferenceAlias  

; int property command auto
Idle Property IdlePointClose  Auto

Spell property firstSpell auto
int property firstSpellType auto
String property firstSpellName auto
int property firstSpellCost auto
Bool property firstSpellCast auto
int property firstSpellSchool auto

Spell property secondSpell auto
int property secondSpellType auto
String property secondSpellName auto
int property secondSpellCost auto
Bool property secondSpellCast auto
int property secondSpellSchool auto

Spell property thirdSpell auto
int property thirdSpellType auto
String property thirdSpellName auto
int property thirdSpellCost auto
Bool property thirdSpellCast auto
int property thirdSpellSchool auto

Spell property fourthSpell auto
int property fourthSpellType auto
String property fourthSpellName auto
int property fourthSpellCost auto
Bool property fourthSpellCast auto
int property fourthSpellSchool auto

bool property combatInProgress auto
bool property waitingforsixseconds auto
ObjectReference property lastTarget auto
int property targetCount auto

Faction property TweakForceSpell1Faction auto
Faction property TweakForceSpell2Faction auto
Faction property TweakForceSpell3Faction auto
Faction property TweakForceSpell4Faction auto
Faction property TweakDisableMagicFaction auto
Faction property WerewolfFaction auto
Faction property TweakUseStaffFaction auto
Faction property TweakHDWerewolfFaction auto
Faction property TweakHDWerebearFaction auto
Faction property TweakHDVampireFaction auto
Faction Property pTweakRegenFaction auto ; New 1.6
Faction Property pTweakAutoHealFaction auto ; New 1.6

FormList property TweakHealingSpells auto
EffectShader Property HealMysticFXS  Auto  
Sound Property MAGRestorationCharge  Auto  

TweakFollowerScript property pTweakFollowerScript auto

Faction property CurrentFollowerFaction auto

; Mages and Spellswords have magic toggle on/off to force staff/weapon use
; There are 6 stages. 
; Mages toggle off on stage 1 (To get staff out) and then remain on through stage 6
; Spellswords toggle off for stage 2,3 and 4, and then on for stage 6,1 and 2  
; Each stage lasts a combat heartbeat (about 6 seconds). 

Int property magicToggle auto
Int property magicRestore auto ; updated by TweakLevelup
Int property magicDamage auto

Function AftReset()

	UnregisterForUpdateGameTime()
	self.GetActorRef().RemoveFromFaction(TweakForceSpell1Faction)
	self.GetActorRef().RemoveFromFaction(TweakForceSpell2Faction)
	self.GetActorRef().RemoveFromFaction(TweakForceSpell3Faction)
	self.GetActorRef().RemoveFromFaction(TweakForceSpell4Faction)
	self.GetActorRef().RemoveFromFaction(TweakDisableMagicFaction)
	self.GetActorRef().RemoveFromFaction(TweakUseStaffFaction)
	self.GetActorRef().RemoveFromFaction(pTweakRegenFaction)
	self.GetActorRef().RemoveFromFaction(pTweakAutoHealFaction)

	combatInProgress = false

	firstSpell = None
	firstSpellType = 0
	firstSpellName = "未設定"
	firstSpellCost = 0
	firstSpellCast = false
	firstSpellSchool = -1

	secondSpell = None
	secondSpellType = 0
	secondSpellName = "未設定"
	secondSpellCost = 0
	secondSpellCast = false
	secondSpellSchool = -1

	thirdSpell = None
	thirdSpellType = 0
	thirdSpellName = "未設定"
	thirdSpellCost = 0
	thirdSpellCast = false
	thirdSpellSchool = -1

	fourthSpell = None
	fourthSpellType = 0
	fourthSpellName = "未設定"
	fourthSpellCost = 0
	fourthSpellCast = false
	fourthSpellSchool = -1

	(GetOwningQuest() As TweakFollowerSpells).ClearNewSpells(self.getActorRef())

endFunction

; One time operations (typically time consuming)
Function initialize()

	Actor npc = self.GetActorRef()
	UnregisterForUpdateGameTime()
	npc.RemoveFromFaction(TweakForceSpell1Faction)
	npc.RemoveFromFaction(TweakForceSpell2Faction)
	npc.RemoveFromFaction(TweakForceSpell3Faction)
	npc.RemoveFromFaction(TweakForceSpell4Faction)
	npc.RemoveFromFaction(TweakDisableMagicFaction)
	npc.RemoveFromFaction(TweakUseStaffFaction)
	npc.AddToFaction(pTweakRegenFaction)
	npc.AddToFaction(pTweakAutoHealFaction)
	
	combatInProgress = false

	firstSpell = None
	firstSpellType = 0
	firstSpellName = "未設定"
	firstSpellCost = 0
	firstSpellCast = false
	firstSpellSchool = -1

	secondSpell = None
	secondSpellType = 0
	secondSpellName = "未設定"
	secondSpellCost = 0
	secondSpellCast = false
	secondSpellSchool = -1

	thirdSpell = None
	thirdSpellType = 0
	thirdSpellName = "未設定"
	thirdSpellCost = 0
	thirdSpellCast = false
	thirdSpellSchool = -1

	fourthSpell = None
	fourthSpellType = 0
	fourthSpellName = "未設定"
	fourthSpellCost = 0
	fourthSpellCast = false
	fourthSpellSchool = -1

	EventFollowingPlayer()

endFunction


Function SetFirstSpell(Spell theSpell, int spellType, String spellName, int spellCost, int spellSchool)

	firstSpell = theSpell
	firstSpellType = spellType
	firstSpellName = spellName
	firstSpellCost = spellCost
	firstSpellSchool = spellSchool

	if (!self.GetActorRef().IsInFaction(TweakDisableMagicFaction))
		self.GetActorRef().AddToFaction(TweakForceSpell1Faction)
		if ((GetOwningQuest() As TweakFollowerScript).showMessages)
			ViewCombatSpells()
		endif
	else
		ViewCombatSpells()
	endif

endFunction	

Function SetSecondSpell(Spell theSpell, int spellType, String spellName, int spellCost, int spellSchool)

	secondSpell = theSpell
	secondSpellType = spellType
	secondSpellName = spellName
	secondSpellCost = spellCost
	secondSpellSchool = spellSchool

	if (!self.GetActorRef().IsInFaction(TweakDisableMagicFaction))
		self.GetActorRef().AddToFaction(TweakForceSpell2Faction)
		if ((GetOwningQuest() As TweakFollowerScript).showMessages)
			ViewCombatSpells()
		endif
	else
		ViewCombatSpells()
	endif

endFunction	

Function SetThirdSpell(Spell theSpell, int spellType, String spellName, int spellCost, int spellSchool)

	thirdSpell = theSpell
	thirdSpellType = spellType
	thirdSpellName = spellName
	thirdSpellCost = spellCost
	thirdSpellSchool = spellSchool

	if (!self.GetActorRef().IsInFaction(TweakDisableMagicFaction))
		self.GetActorRef().AddToFaction(TweakForceSpell3Faction)
		if ((GetOwningQuest() As TweakFollowerScript).showMessages)
			ViewCombatSpells()
		endif
	else
		ViewCombatSpells()
	endif

endFunction	

Function SetFourthSpell(Spell theSpell, int spellType, String spellName, int spellCost, int spellSchool)

	fourthSpell = theSpell
	fourthSpellType = spellType
	fourthSpellName = spellName
	fourthSpellCost = spellCost
	fourthSpellSchool = spellSchool

	if (!self.GetActorRef().IsInFaction(TweakDisableMagicFaction))
		self.GetActorRef().AddToFaction(TweakForceSpell4Faction)
		if ((GetOwningQuest() As TweakFollowerScript).showMessages)
			ViewCombatSpells()
		endif
	else
		ViewCombatSpells()
	endif

endFunction	

Function ToggleFirstSpellUse(Bool value)

;	if (value)
;		if (firstSpell)
;			self.GetActorRef().AddToFaction(TweakForceSpell1Faction)
;		else
;			Debug.MessageBox("最初に呪文をセットする必要があります。")
;		endif
;	else
;		self.GetActorRef().RemoveFromFaction(TweakForceSpell1Faction)
;	endif

	self.GetActorRef().RemoveFromFaction(TweakForceSpell1Faction)
	firstSpell = None
	firstSpellType = 0
	firstSpellName = "未設定"
	firstSpellCost = 0
	firstSpellCast = false
	firstSpellSchool = -1

endFunction	

Function ToggleSecondSpellUse(Bool value)
	self.GetActorRef().RemoveFromFaction(TweakForceSpell2Faction)
	secondSpell = None
	secondSpellType = 0
	secondSpellName = "未設定"
	secondSpellCost = 0
	secondSpellCast = false
	secondSpellSchool = -1
endFunction

Function ToggleThirdSpellUse(Bool value)
	self.GetActorRef().RemoveFromFaction(TweakForceSpell3Faction)
	thirdSpell = None
	thirdSpellType = 0
	thirdSpellName = "未設定"
	thirdSpellCost = 0
	thirdSpellCast = false
	thirdSpellSchool = -1
endFunction

Function ToggleFourthSpellUse(Bool value)
	self.GetActorRef().RemoveFromFaction(TweakForceSpell4Faction)
	fourthSpell = None
	fourthSpellType = 0
	fourthSpellName = "未設定"
	fourthSpellCost = 0
	fourthSpellCast = false
	fourthSpellSchool = -1
endFunction

Int Function GetActualCost(int base, int school)
	Actor npc = self.GetActorRef()
	int actualcost

	; Schools
	; -1 = None
	; 0 = Alteration 
	; 1 = Conjuration 
	; 2 = Destruction 
	; 3 = Illusion 
	; 4 = Restoration

	if (school != -1)
		float skill  = 0.0
		if 0 == school
			skill = npc.GetAV("Alteration")
		elseif 1 == school
			skill = npc.GetAV("Conjuration")
		elseif 2 == school 
			skill = npc.GetAV("Destruction")
		elseif 3 == school 
			skill = npc.GetAV("Illusion")
		elseif 4 == school
			skill = npc.GetAV("Restoration")
		endif		
		actualcost = (base - (base * (0.71 * skill/100))) As Int		
	else
		actualcost = base
	endif
	return actualcost
	
EndFunction

Int Function GetActualHeal(int base)
	Actor npc = self.GetActorRef()
	float skill = npc.GetAV("Restoration")
	int actualheal = (base + base * (2.5 * skill/100)) As Int
	return actualheal
EndFunction

Function ViewCombatSpells()

	int tCost = 0
	
	int fmagicka = (self.GetActorRef().GetAv("magicka") as Int)
	bool warn = false
    	string status = "設定呪文:\n"
	if (self.GetActorRef().IsInFaction(TweakDisableMagicFaction))
		status += "(現在の設定では呪文の使用が禁止されています。)\n\n"
	else
		status += "\n"
	endif

	int firstspellactualcost = GetActualCost(firstSpellCost, firstSpellSchool)
	int secondspellactualcost = GetActualCost(secondSpellCost, secondSpellSchool)
	int thirdspellactualcost = GetActualCost(thirdSpellCost, thirdSpellSchool)
	int fourthspellactualcost = GetActualCost(fourthSpellCost, fourthSpellSchool)
			
	status += " [呪文]  [タイプ][条件][マジカ]\n"
	status += "-------------------------------\n"
	if (self.GetActorRef().IsInFaction(TweakForceSpell1Faction))
		tCost += firstspellactualcost
	endif
	status += "[" + firstSpellName + "] "
	if (0 == firstSpellType) 
		status += "[攻撃][標的1] "
	elseif (1 == firstSpellType)
		status += "[PC強化][体力100] "
	elseif (2 == firstSpellType)
		status += "[召喚][標的1] "
	elseif (3 == firstSpellType)
		status += "[NPC強化][体力100] "
	elseif (4 == firstSpellType)
		status += "[NPC強化][体力75] "
	elseif (5 == firstSpellType)
		status += "[NPC強化][体力50] "
	elseif (6 == firstSpellType)
		status += "[NPC強化][体力25] "
	elseif (7 == firstSpellType)
		status += "[PC強化][体力75] "
	elseif (8 == firstSpellType)
		status += "[PC強化][体力50] "
	elseif (9 == firstSpellType)
		status += "[PC強化][体力25] "
	elseif (10 == firstSpellType) 
		status += "[攻撃][標的2] "
	elseif (11 == firstSpellType) 
		status += "[攻撃][標的3] "
	endif
	status += "[" + firstspellactualcost + "]\n"

	if (self.GetActorRef().IsInFaction(TweakForceSpell2Faction))
		tCost += secondspellactualcost
	endif

	status += "[" + secondSpellName + "] "
	if (0 == secondSpellType) 
		status += "[攻撃][標的1] "
	elseif (1 == secondSpellType)
		status += "[PC強化][体力100] "
	elseif (2 == secondSpellType)
		status += "[召喚][標的1] "
	elseif (3 == secondSpellType)
		status += "[NPC強化][体力100] "
	elseif (4 == secondSpellType)
        	status += "[NPC強化][体力75] "
	elseif (5 == secondSpellType)
		status += "[NPC強化][体力50] "
	elseif (6 == secondSpellType)
		status += "[NPC強化][体力25] "
	elseif (7 == secondSpellType)
		status += "[PC強化][体力75] "
	elseif (8 == secondSpellType)
		status += "[PC強化][体力50] "
	elseif (9 == secondSpellType)
		status += "[PC強化][体力25] "
	elseif (10 == secondSpellType) 
		status += "[攻撃][標的2] "
	elseif (11 == secondSpellType) 
		status += "[攻撃][標的3] "
	endif
	status += "[" + secondspellactualcost + "]\n"


	if (self.GetActorRef().IsInFaction(TweakForceSpell3Faction))
		tCost += thirdspellactualcost
	endif

	status += "[" + thirdSpellName + "] "
        if (0 == thirdSpellType) 
		status += "[攻撃][標的1] "
	elseif (1 == thirdSpellType)
		status += "[PC強化][体力100] "
	elseif (2 == thirdSpellType)
		status += "[召喚][標的1] "
	elseif (3 == thirdSpellType)
		status += "[NPC強化][体力100] "
	elseif (4 == thirdSpellType)
        	status += "[NPC強化][体力75] "
	elseif (5 == thirdSpellType)
		status += "[NPC強化][体力50] "
	elseif (6 == thirdSpellType)
		status += "[NPC強化][体力25] "
	elseif (7 == thirdSpellType)
		status += "[PC強化][体力75] "
	elseif (8 == thirdSpellType)
		status += "[PC強化][体力50] "
	elseif (9 == thirdSpellType)
		status += "[PC強化][体力25] "
	elseif (10 == thirdSpellType) 
		status += "[攻撃][標的2] "
	elseif (11 == thirdSpellType) 
		status += "[攻撃][標的3] "
	endif
	status += "[" + thirdspellactualcost + "]\n"

	if (self.GetActorRef().IsInFaction(TweakForceSpell4Faction))
		tCost += fourthspellactualcost
	endif

	status += "[" + fourthSpellName + "] "
        if (0 == fourthSpellType) 
		status += "[攻撃][標的1] "
	elseif (1 == fourthSpellType)
		status += "[PC強化][体力100] "
	elseif (2 == fourthSpellType)
		status += "[召喚][標的1] "
	elseif (3 == fourthSpellType)
		status += "[NPC強化][体力100] "
	elseif (4 == fourthSpellType)
        	status += "[NPC強化][体力75] "
	elseif (5 == fourthSpellType)
		status += "[NPC強化][体力50] "
	elseif (6 == fourthSpellType)
		status += "[NPC強化][体力25] "
	elseif (7 == fourthSpellType)
		status += "[PC強化][体力75] "
	elseif (8 == fourthSpellType)
		status += "[PC強化][体力50] "
	elseif (9 == fourthSpellType)
		status += "[PC強化][体力25] "
	elseif (10 == fourthSpellType) 
		status += "[攻撃][標的2] "
	elseif (11 == fourthSpellType) 
		status += "[攻撃][標的3] "
	endif
	status += "[" + fourthspellactualcost + "]\n"

	status += "-------------------------------\n"
	int remaining = fmagicka - tCost
	if remaining < 0
		remaining = 0
		warn = true
	endif
	status += "マジカ: 総量 [" + fmagicka + "] 使用 [" + tCost + "] \n    残量 [" + remaining + "]"
	if (warn)
		status += "\n*全呪文詠唱にはマジカ不足*"
	endif
	Debug.MessageBox(status)

endFunction

; Every time they begin following the PC when previously not following the pc at all. 
Function EventFollowingPlayer()
	; If we have overridden thenir default combat type, we may have to re-enable magic use
endFunction

; Every time they continue following the PC after waiting
Function EventWaitToFollow()
	; Nothing to do right now.
EndFunction

; When they stop following the PC
Function EventNotFollowingPlayer()

	; Actor npc = self.GetActorRef()
	UnRegisterForUpdateGameTime()

endFunction

Function OnCombatBegin(Actor akTarget=None)
	combatInProgress = true

	if (!akTarget)
		Return
	EndIf
	Actor npc = self.GetActorRef()
	; If possessing the follower, we dont care
	if (npc.GetPlayerControls())
		return
	endif

	; If too far away and waiting, nothing we can do:
	if (0 != (npc.GetAv("WaitingforPlayer") as Int))
		if (Game.GetPlayer().GetDistance(self.GetRef()) > 2000)
			return
		endif
	endif
	
	if (0 == magicRestore)
		magicRestore = npc.GetAV("Magicka") As Int
	endif
	RegisterForUpdateGameTime(0.05) ; about once every 7.5 seconds
	lastTarget = akTarget
	targetCount = 1
	firstSpellCast = false
	secondSpellCast = false
	thirdSpellCast = false
	fourthSpellCast = false

	if (npc.IsInFaction(TweakForceSpell1Faction))
		if (firstSpellType < 4)
			firstSpellCast = true
			FollowerCast(firstSpell, firstSpellType, firstSpellCost, akTarget, firstSpellName, firstSpellSchool)
		endif
	else
		firstSpellCast = true
	endif
	if (npc.IsInFaction(TweakForceSpell2Faction))
		if (secondSpellType < 4)
			secondSpellCast = true
			FollowerCast(secondSpell, secondSpellType, secondSpellCost, akTarget, secondSpellName, secondSpellSchool)
		endif
	else
		secondSpellCast = true
	endif
	if (npc.IsInFaction(TweakForceSpell3Faction))
		if (thirdSpellType < 4)
			thirdSpellCast = true
			FollowerCast(thirdSpell, thirdSpellType, thirdSpellCost, akTarget, thirdSpellName, thirdSpellSchool)
		endif
	else
		thirdSpellCast = true
	endif
	if (npc.IsInFaction(TweakForceSpell4Faction))
		if (fourthSpellType < 4)
			fourthSpellCast = true
			FollowerCast(fourthSpell, fourthSpellType, fourthSpellCost, akTarget, fourthSpellName, fourthSpellSchool)
		endif
	else
		fourthSpellCast = true
	endif	
EndFunction

; Called by TweakFollowerScript: RelayCombatEnd
Function OnCombatEnd()
	combatInProgress = false

	targetCount = 0
	lastTarget = None
	waitingforsixseconds = false
	UnregisterForUpdateGameTime()
	firstSpellCast = false
	secondSpellCast = false
	thirdSpellCast = false
	fourthSpellCast = false

	Actor npc = self.GetActorRef()

	; If possessing the follower, we dont care
	if (npc.GetPlayerControls())
		return
	endif	
	
	if (0 != magicRestore)
		if (!npc.IsInFaction(TweakDisableMagicFaction) && !npc.IsInFaction(WerewolfFaction))
			npc.SetAV("Magicka", magicRestore)
		endif
	endif
		
	; I know double negatives are awkward, but the game initializes new booleans
	; as false, so insead of if InstantHeal we use if !DisableInstantHeal

	; When followers are essential, they instant heal between targets. 
	; When they are mortal, they dont. (Dont know why). Some people may
	; want to heal their followers (to gain healing spell skills)
		
	if (npc.IsInFaction(pTweakAutoHealFaction))
		; String Name = ((Self As ReferenceAlias) As TweakSettings).originalName
		; Debug.Notification("[" + Name + "] Restoring Health")
		npc.RestoreAV("Health", 9999)
		npc.RestoreAV("Stamina", 9999)
		npc.RestoreAV("Magicka", 9999)
	endif

	
EndFunction

Event OnCombatStateChanged(Actor akTarget, int cState)

	Actor npc = self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf
	if (1 != cState)
		Return
	EndIf
	
	if (akTarget && akTarget.IsPlayerTeammate())
		return
	endif

	if (!npc.IsInFaction(CurrentFollowerFaction))
		return
	endif

	if (!combatInProgress)
		OnCombatBegin(akTarget)
	endif
		
endEvent

Event OnUpdateGameTime()

	Actor npc = self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf

	if (npc.IsInFaction(pTweakRegenFaction))
		npc.RestoreAV("Health", 10)
		npc.RestoreAV("Stamina", 10)
		npc.RestoreAV("Magicka", 10)
	endif
	CheckMagicToggle()
	CheckWerewolf()
	CheckHealth()
	CheckTarget()
	; waitingforsixseconds = false

endEvent

Function v16Upgrade()
	if (!pTweakFollowerScript.DisableInstantHeal)
		self.GetActorRef().AddToFaction(pTweakAutoHealFaction)
	endif
	if (pTweakFollowerScript.followerRegen)
		self.GetActorRef().AddToFaction(pTweakRegenFaction)
	endif
EndFunction

Function v161Upgrade()
	TweakFollowerSpells pTweakFollowerSpells = GetOwningQuest() As TweakFollowerSpells
	if (pTweakFollowerSpells)
		int index
		if (firstSpell)
			index = pTweakFollowerSpells.GetSpellIndex(firstSpell)
			if (-1 != index)
				firstSpellSchool = pTweakFollowerSpells.GetSpellSchool(index)
			endif
		endif
		if (secondSpell)
			index = pTweakFollowerSpells.GetSpellIndex(secondSpell)
			if (-1 != index)
				secondSpellSchool = pTweakFollowerSpells.GetSpellSchool(index)
			endif
		endif
		if (thirdSpell)
			index = pTweakFollowerSpells.GetSpellIndex(thirdSpell)
			if (-1 != index)
				thirdSpellSchool = pTweakFollowerSpells.GetSpellSchool(index)
			endif
		endif
		if (fourthSpell)
			index = pTweakFollowerSpells.GetSpellIndex(fourthSpell)
			if (-1 != index)
				fourthSpellSchool = pTweakFollowerSpells.GetSpellSchool(index)
			endif
		endif
	EndIf
EndFunction

Function CheckWerewolf()

	Actor npc = self.GetActorRef()
	if npc.IsInFaction(TweakHDWerewolfFaction)
		if (self.GetActorRef().GetAVPercentage("Health") < 0.50)
			TweakWerewolf pTweakWerewolf = (self as ReferenceAlias) As TweakWerewolf
			if (pTweakWerewolf)
				pTweakWerewolf.TransformWerewolf()
			endif
		endif
	elseif npc.IsInFaction(TweakHDVampireFaction)
		if (self.GetActorRef().GetAVPercentage("Health") < 0.50)
			TweakVampireLord pTweakVampireLord = (self as ReferenceAlias) As TweakVampireLord
			if (pTweakVampireLord)
				pTweakVampireLord.TransformVampire()
			endif
		endif
	elseif npc.IsInFaction(TweakHDWerebearFaction)
		if (self.GetActorRef().GetAVPercentage("Health") < 0.50)
			TweakWerebear pTweakWerebear = (self as ReferenceAlias) As TweakWerebear
			if (pTweakWerebear)
				pTweakWerebear.TransformWerebear()
			endif
		endif
	endif

endFunction

Function CheckMagicToggle()
	if (0 == magicRestore)
		return
	endif
	magicToggle += 1
	if (7 == magicToggle)
		magicToggle = 1
	endif

	Actor npc = self.GetActorRef()
	int combatType = npc.GetAV("FavorsPerDayTimer") As Int

	if (731 == combatType) ; mage
		if (!npc.IsInFaction(TweakUseStaffFaction))
			return
		endif
		if (1 == magicToggle)
			magicDamage = magicRestore - (npc.GetAV("Magicka") As Int)
			magicDamage -= 10
			if (magicDamage < 0)
				magicDamage = 0
			endif
			npc.SetAV("Magicka", 0)
		elseif (2 == magicToggle)
			npc.SetAV("Magicka", magicRestore)
			if (magicDamage != 0)	
				npc.DamageAV("Magicka", magicDamage)
			endif
		endif
	elseif (732 == combatType) ; spellsword
		if (3 == magicToggle)
			magicDamage = magicRestore - (npc.GetAV("Magicka") As Int)
			magicDamage -= 10
			if (magicDamage < 0)
				magicDamage = 0
			endif
			npc.SetAV("Magicka", 0)
		elseif (6 == magicToggle)
			npc.SetAV("Magicka", magicRestore)
			if (magicDamage != 0)	
				npc.DamageAV("Magicka", magicDamage)
			endif
		endif
	endif		
EndFunction

Function CheckTarget()

	Actor akTarget = self.GetActorRef().GetCombatTarget()
	if (akTarget && !aktarget.IsDead() && akTarget != lastTarget)
		targetCount += 1
		if (targetCount == 2)
			if (10 == firstSpellType && !firstSpellCast)
				firstSpellCast = true
				FollowerCast(firstSpell, 0, firstSpellCost, akTarget, firstSpellName, firstSpellSchool)
			endif
			if (10 == secondSpellType && !secondSpellCast)
				secondSpellCast = true
				FollowerCast(secondSpell, 0, secondSpellCost, akTarget, secondSpellName, secondSpellSchool)
			endif
			if (10 == thirdSpellType && !thirdSpellCast)
				thirdSpellCast = true
				FollowerCast(thirdSpell, 0, thirdSpellCost, akTarget, thirdSpellName, thirdSpellSchool)
			endif
			if (10 == fourthSpellType && !fourthSpellCast)
				fourthSpellCast = true
				FollowerCast(fourthSpell, 0, fourthSpellCost, akTarget, fourthSpellName, fourthSpellSchool)
			endif
		elseif (targetCount == 3)
			if (11 == firstSpellType && !firstSpellCast)
				firstSpellCast = true
				FollowerCast(firstSpell, 0, firstSpellCost, akTarget, firstSpellName, firstSpellSchool)
			endif
			if (11 == secondSpellType && !secondSpellCast)
				secondSpellCast = true
				FollowerCast(secondSpell, 0, secondSpellCost, akTarget, secondSpellName, secondSpellSchool)
			endif
			if (11 == thirdSpellType && !thirdSpellCast)
				thirdSpellCast = true
				FollowerCast(thirdSpell, 0, thirdSpellCost, akTarget, thirdSpellName, thirdSpellSchool)
			endif
			if (11 == fourthSpellType && !fourthSpellCast)
				fourthSpellCast = true
				FollowerCast(fourthSpell, 0, fourthSpellCost, akTarget, fourthSpellName, fourthSpellSchool)
			endif
		endif
	endif
endFunction

; v1.3 update - Health spells can cast more than once per combat.
; logic re-arranged to minimize conditions...
Function CheckHealth()

	;Actor akTarget = self.GetActorRef().GetCombatTarget()	
	Actor pc = Game.GetPlayer()
	Actor npc = self.GetActorRef()
	
	if (!firstSpellCast && firstSpellType > 3 && firstSpellType < 10)
		if (7 == firstSpellType)
			if (pc.GetAVPercentage("Health") < 0.75)
				FollowerCast(firstSpell, 1, firstSpellCost, None, firstSpellName, firstSpellSchool)
			endif
		elseif (8 == firstSpellType)
			if (pc.GetAVPercentage("Health") < 0.5)
				FollowerCast(firstSpell, 1, firstSpellCost, None, firstSpellName, firstSpellSchool)
			endif
		elseif (9 == firstSpellType)
			if (pc.GetAVPercentage("Health") < 0.25)
				FollowerCast(firstSpell, 1, firstSpellCost, None, firstSpellName, firstSpellSchool)
			endif
		elseif (4 == firstSpellType)
			if (npc.GetAVPercentage("Health") < 0.75)
				FollowerCast(firstSpell, 3, firstSpellCost, None, firstSpellName, firstSpellSchool)
			endif
		elseif (5 == firstSpellType)
			if (npc.GetAVPercentage("Health") < 0.50)
				FollowerCast(firstSpell, 3, firstSpellCost, None, firstSpellName, firstSpellSchool)
			endif
		elseif (npc.GetAVPercentage("Health") < 0.25)
			FollowerCast(firstSpell, 3, firstSpellCost, None, firstSpellName, firstSpellSchool)
		endif
	endif

	if (!secondSpellCast && secondSpellType > 3 && secondSpellType < 10)
		if (7 == secondSpellType)
			if (pc.GetAVPercentage("Health") < 0.75)
				FollowerCast(secondSpell, 1, secondSpellCost, None, secondSpellName, secondSpellSchool)
			endif
		elseif (8 == secondSpellType)
			if (pc.GetAVPercentage("Health") < 0.5)
				FollowerCast(secondSpell, 1, secondSpellCost, None, secondSpellName, secondSpellSchool)
			endif
		elseif (9 == secondSpellType)
			if (pc.GetAVPercentage("Health") < 0.25)
				FollowerCast(secondSpell, 1, secondSpellCost, None, secondSpellName, secondSpellSchool)
			endif
		elseif (4 == secondSpellType)
			if (npc.GetAVPercentage("Health") < 0.75)
				FollowerCast(secondSpell, 3, secondSpellCost, None, secondSpellName, secondSpellSchool)
			endif
		elseif (5 == secondSpellType)
			if (npc.GetAVPercentage("Health") < 0.50)
				FollowerCast(secondSpell, 3, secondSpellCost, None, secondSpellName, secondSpellSchool)
			endif
		elseif (npc.GetAVPercentage("Health") < 0.25)
			FollowerCast(secondSpell, 3, secondSpellCost, None, secondSpellName, secondSpellSchool)
		endif
	endif

	if (!thirdSpellCast && thirdSpellType > 3 && thirdSpellType < 10)
		if (7 == thirdSpellType)
			if (pc.GetAVPercentage("Health") < 0.75)
				FollowerCast(thirdSpell, 1, thirdSpellCost, None, thirdSpellName, thirdSpellSchool)
			endif
		elseif (8 == thirdSpellType)
			if (pc.GetAVPercentage("Health") < 0.5)
				FollowerCast(thirdSpell, 1, thirdSpellCost, None, thirdSpellName, thirdSpellSchool)
			endif
		elseif (9 == thirdSpellType)
			if (pc.GetAVPercentage("Health") < 0.25)
				FollowerCast(thirdSpell, 1, thirdSpellCost, None, thirdSpellName, thirdSpellSchool)
			endif
		elseif (4 == thirdSpellType)
			if (npc.GetAVPercentage("Health") < 0.75)
				FollowerCast(thirdSpell, 3, thirdSpellCost, None, thirdSpellName, thirdSpellSchool)
			endif
		elseif (5 == thirdSpellType)
			if (npc.GetAVPercentage("Health") < 0.50)
				FollowerCast(thirdSpell, 3, thirdSpellCost, None, thirdSpellName, thirdSpellSchool)
			endif
		elseif (npc.GetAVPercentage("Health") < 0.25)
			FollowerCast(thirdSpell, 3, thirdSpellCost, None, thirdSpellName, thirdSpellSchool)
		endif
	endif
	
	if (!fourthSpellCast && fourthSpellType > 3 && fourthSpellType < 10)
		if (7 == fourthSpellType)
			if (pc.GetAVPercentage("Health") < 0.75)
				FollowerCast(fourthSpell, 1, fourthSpellCost, None, fourthSpellName, fourthSpellSchool)
			endif
		elseif (8 == fourthSpellType)
			if (pc.GetAVPercentage("Health") < 0.5)
				FollowerCast(fourthSpell, 1, fourthSpellCost, None, fourthSpellName, fourthSpellSchool)
			endif
		elseif (9 == fourthSpellType)
			if (pc.GetAVPercentage("Health") < 0.25)
				FollowerCast(fourthSpell, 1, fourthSpellCost, None, fourthSpellName, fourthSpellSchool)
			endif
		elseif (4 == fourthSpellType)
			if (npc.GetAVPercentage("Health") < 0.75)
				FollowerCast(fourthSpell, 3, fourthSpellCost, None, fourthSpellName, fourthSpellSchool)
			endif
		elseif (5 == fourthSpellType)
			if (npc.GetAVPercentage("Health") < 0.50)
				FollowerCast(fourthSpell, 3, fourthSpellCost, None, fourthSpellName, fourthSpellSchool)
			endif
		elseif (npc.GetAVPercentage("Health") < 0.25)
			FollowerCast(fourthSpell, 3, fourthSpellCost, None, fourthSpellName, fourthSpellSchool)
		endif
	endif

endFunction



Function SetDisableMagic(Bool value)

	if (value)
		self.GetActorRef().addToFaction(TweakDisableMagicFaction)

		; SetAV is not reliable on Magicka
		int current = self.GetActorRef().GetAV("Magicka") As Int
		if (0 != current)
			self.GetActorRef().SetAv("Magicka", 0)
			if (0 != (self.GetActorRef().GetAv("Magicka") as Int))
				self.GetActorRef().ForceAv("Magicka", 0)
			endif
		endif
		self.GetActorRef().RemoveFromFaction(TweakForceSpell1Faction)
		self.GetActorRef().RemoveFromFaction(TweakForceSpell2Faction)
		self.GetActorRef().RemoveFromFaction(TweakForceSpell3Faction)
		self.GetActorRef().RemoveFromFaction(TweakForceSpell4Faction)
	else
		self.GetActorRef().RemoveFromFaction(TweakDisableMagicFaction)
		((self As ReferenceAlias) As TweakLevelUp).ResetAndLevelUp()
	endif

endFunction
	
Function ClearCombatSpells()

	self.GetActorRef().RemoveFromFaction(TweakForceSpell1Faction)
	self.GetActorRef().RemoveFromFaction(TweakForceSpell2Faction)
	self.GetActorRef().RemoveFromFaction(TweakForceSpell3Faction)
	self.GetActorRef().RemoveFromFaction(TweakForceSpell4Faction)

	firstSpell = None
	firstSpellType = 0
	firstSpellName = "未設定"
	firstSpellCost = 0
	firstSpellCast = false
	firstSpellSchool = -1

	secondSpell = None
	secondSpellType = 0
	secondSpellName = "未設定"
	secondSpellCost = 0
	secondSpellCast = false
	secondSpellSchool = -1

	thirdSpell = None
	thirdSpellType = 0
	thirdSpellName = "未設定"
	thirdSpellCost = 0
	thirdSpellCast = false
	thirdSpellSchool = -1

	fourthSpell = None
	fourthSpellType = 0
	fourthSpellName = "未設定"
	fourthSpellCost = 0
	fourthSpellCast = false
	fourthSpellSchool = -1

endFunction

Function ToggleRegen(bool pRegen)
	Actor npc = self.GetActorRef()
	if (pRegen)
		npc.AddToFaction(pTweakRegenFaction)
	Else
		npc.RemoveFromFaction(pTweakRegenFaction)
	endif
EndFunction

Function ToggleAutoHeal(bool pAutoHeal)
	Actor npc = self.GetActorRef()
	if (pAutoHeal)
		npc.AddToFaction(pTweakAutoHealFaction)
	Else
		npc.RemoveFromFaction(pTweakAutoHealFaction)
	endif
EndFunction

Function FollowerCast(Spell theSpell, int spellType, int spellCost, Actor combatTarget, String spellName, int spellSchool)

	int magicka = (self.GetActorRef().GetAV("Magicka") As Int) + 1
	int spellactualcost = GetActualCost(spellCost, spellSchool)

	if (magicka > spellactualcost)
		TweakSettings pTweakSettings = (self as ReferenceAlias) as TweakSettings

		; Removed spell check. If we add spells to follower known spells, AI will automatically have them 
		; cast them mid combat. To avoid this, we dont add the spells, we simply tell them to cast them directly
		Actor npc = self.GetActorRef()
		npc.StopCombat()
		npc.PlayIdle(IdlePointClose)
		Utility.wait(1.5)
		npc.DamageAV("Magicka", spellactualcost)
		if (1 == spellType) ; Target PC
			theSpell.cast(npc,Game.GetPlayer())
			Debug.Notification(pTweakSettings.originalName + " casts [" + spellName + "] on Player")
			if TweakHealingSpells.hasForm(theSpell)
				HealMysticFXS.play(Game.GetPlayer())
				MAGRestorationCharge.Play(Game.GetPlayer())
				Utility.wait(1.0)
				Game.GetPlayer().RestoreAV("Health", GetActualHeal(spellCost))
				Utility.wait(1.0)
				HealMysticFXS.stop(Game.GetPlayer())
			 endif
		elseif (2 == spellType) ; (Summon)
			theSpell.cast(npc)
			Debug.Notification(pTweakSettings.originalName + " casts [" + spellName + "]")
		elseif (3 == spellType) ; Target self
			theSpell.cast(npc)
			Debug.Notification(pTweakSettings.originalName + " casts [" + spellName + "]")
			if TweakHealingSpells.hasForm(theSpell)
				HealMysticFXS.play(npc)
				MAGRestorationCharge.Play(npc)
				Utility.wait(1.0)
				npc.RestoreAV("Health", spellCost)
				Utility.wait(1.0)
				HealMysticFXS.stop(npc)
			endif
		else ; 0  - Target enemy
			; theSpell.cast(npc, combatTarget)
			npc.DoCombatSpellApply(theSpell, combatTarget)
			Debug.Notification(pTweakSettings.originalName + " casts [" + spellName + "] on Enemy")
		endif
		Utility.wait(0.2)
	endif

endFunction

; Deprecated 1.6
bool property restorehealth auto

; Deprecated 1.51
Faction property TweakPTWerewolfFaction auto

