﻿Scriptname TweakMakeFollowerScript extends ActiveMagicEffect  

; The difference between Potential and Import is that we expect members 
; of Potential to only need the Manage With AFT and maybe Follow Me 
; conversations. ImportFaction assumes a dog or some Actor type that 
; probably wont generate the needed dismiss/wait/Follow dialogue options.

Faction Property pTweakPotentialFollowerFaction Auto
Faction Property pTweakImportFaction Auto
Faction Property pCurrentFollowerFaction Auto
Faction Property pPotentialFollowerFaction Auto
Faction Property pJobJarlFaction Auto

Quest Property pTweakFollower Auto
Keyword Property ActorTypeNPC Auto

Message Property pTweakPotentialVanillaMsg Auto
Message Property pTweakPotentialMsg Auto
Message Property pTweakCurrentMsg Auto
Message Property pTweakCurrentVanillaMsg Auto
Message Property pTweakMFWarningCustom Auto
Message Property pTweakMFWarningVanilla Auto
Message Property pTweakEFWarning Auto
Message Property pTweakEFWarningVanilla Auto
Message Property pTweakUndoFollower Auto


Event OnEffectStart(Actor akTarget, Actor akCaster)
	if (!akTarget)
		return
	endif
	if akTarget == Game.GetPlayer()
		return
	endif
	If (akTarget.IsCommandedActor())
		Debug.Notification("Resisted: Target is Summoned Creature")
		return
	endif
	If (akTarget.IsInCombat())
		Debug.Notification("Resisted: Target In Combat")
		return
	endif
	If (akTarget.IsAlarmed())
		Debug.Notification("Resisted: Target is Alarmed")
		return
	endif
	
	Bool undo = False
	if (0 != akTarget.GetAV("FavorActive"))
		ReferenceAlias ref = pTweakFollower.GetAlias(44) as ReferenceAlias
		if (ref)
			ref.ForceRefTo(akTarget)
		endif
		int doReset = pTweakUndoFollower.show()
		if (1 == doReset)
			return
		endif
		TweakFollowerScript pTweakFollowerScript = pTweakFollower As TweakFollowerScript
		if (pTweakFollowerScript)
			pTweakFollowerScript.ResetFollower(akTarget)
		Else
			Debug.MessageBox("NPCの初期化ができません")
		endif
		return
	endif


	if (akTarget.IsInFaction(pTweakPotentialFollowerFaction))
		Debug.Notification("Resisted: Spell already in effect")
		return
	endif
	if (akTarget.IsInFaction(pTweakImportFaction))
		Debug.Notification("Resisted: Spell already in effect")
		return
	endif
	
	ReferenceAlias ref = pTweakFollower.GetAlias(44) as ReferenceAlias
	if (ref)
		ref.ForceRefTo(akTarget)
	endif
	
	If (akTarget.IsInFaction(pCurrentFollowerFaction))
		int continue = 0
		if (akTarget.GetFormId() < 0x01000000)
			continue = pTweakCurrentVanillaMsg.show()
		else
			continue = pTweakCurrentMsg.show()
		endif
		if (1 == continue)
			return
		endif
	elseif akTarget.IsInFaction(pPotentialFollowerFaction)
		int continue = 0
		if (akTarget.GetFormId() < 0x01000000)
			continue = pTweakPotentialVanillaMsg.show()
		else
			continue = pTweakPotentialMsg.show()
		endif
		if (1 == continue)
			return
		endif
	endif
	
	if (akTarget.IsEssential() || akTarget.GetActorBase().IsEssential() || akTarget.IsInFaction(pJobJarlFaction))
		int continue = 0
		if (akTarget.GetFormId() < 0x01000000)
			continue = pTweakEFWarningVanilla.show()
		else
			continue = pTweakEFWarning.show()
		endif
		if (1 == continue)
			return
		endif	
	endif

	if (akTarget.HasKeyword(ActorTypeNPC) && !akTarget.isChild())
		akTarget.AddToFaction(pTweakPotentialFollowerFaction)
	else
		akTarget.AddToFaction(pTweakImportFaction)			
	endif
	
	if (akTarget.GetFormId() < 0x01000000)
		pTweakMFWarningVanilla.show()
	else
		pTweakMFWarningCustom.show()
	endif

EndEvent

